# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs

__all__ = [
    'GetAccessPolicyAssignmentResult',
    'AwaitableGetAccessPolicyAssignmentResult',
    'get_access_policy_assignment',
    'get_access_policy_assignment_output',
]

@pulumi.output_type
class GetAccessPolicyAssignmentResult:
    """
    Describes the access policy assignment of Redis Enterprise database
    """
    def __init__(__self__, access_policy_name=None, id=None, name=None, provisioning_state=None, type=None, user=None):
        if access_policy_name and not isinstance(access_policy_name, str):
            raise TypeError("Expected argument 'access_policy_name' to be a str")
        pulumi.set(__self__, "access_policy_name", access_policy_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if user and not isinstance(user, dict):
            raise TypeError("Expected argument 'user' to be a dict")
        pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter(name="accessPolicyName")
    def access_policy_name(self) -> str:
        """
        Name of access policy under specific access policy assignment. Only "default" policy is supported for now.
        """
        return pulumi.get(self, "access_policy_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        Current provisioning status of the access policy assignment.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def user(self) -> 'outputs.AccessPolicyAssignmentPropertiesResponseUser':
        """
        The user associated with the access policy.
        """
        return pulumi.get(self, "user")


class AwaitableGetAccessPolicyAssignmentResult(GetAccessPolicyAssignmentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAccessPolicyAssignmentResult(
            access_policy_name=self.access_policy_name,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            type=self.type,
            user=self.user)


def get_access_policy_assignment(access_policy_assignment_name: Optional[str] = None,
                                 cluster_name: Optional[str] = None,
                                 database_name: Optional[str] = None,
                                 resource_group_name: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAccessPolicyAssignmentResult:
    """
    Gets information about access policy assignment for database.


    :param str access_policy_assignment_name: The name of the Redis Enterprise database access policy assignment.
    :param str cluster_name: The name of the Redis Enterprise cluster.
    :param str database_name: The name of the Redis Enterprise database.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['accessPolicyAssignmentName'] = access_policy_assignment_name
    __args__['clusterName'] = cluster_name
    __args__['databaseName'] = database_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:cache/v20240901preview:getAccessPolicyAssignment', __args__, opts=opts, typ=GetAccessPolicyAssignmentResult).value

    return AwaitableGetAccessPolicyAssignmentResult(
        access_policy_name=pulumi.get(__ret__, 'access_policy_name'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        type=pulumi.get(__ret__, 'type'),
        user=pulumi.get(__ret__, 'user'))


@_utilities.lift_output_func(get_access_policy_assignment)
def get_access_policy_assignment_output(access_policy_assignment_name: Optional[pulumi.Input[str]] = None,
                                        cluster_name: Optional[pulumi.Input[str]] = None,
                                        database_name: Optional[pulumi.Input[str]] = None,
                                        resource_group_name: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAccessPolicyAssignmentResult]:
    """
    Gets information about access policy assignment for database.


    :param str access_policy_assignment_name: The name of the Redis Enterprise database access policy assignment.
    :param str cluster_name: The name of the Redis Enterprise cluster.
    :param str database_name: The name of the Redis Enterprise database.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
