# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CreateMode',
    'HighAvailabilityMode',
    'PreviewFeature',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccess',
]


class CreateMode(str, Enum):
    """
    The mode to create a mongo cluster.
    """
    DEFAULT = "Default"
    """
    Create a new mongo cluster.
    """
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"
    """
    Create a mongo cluster from a restore point-in-time.
    """
    GEO_REPLICA = "GeoReplica"
    """
    Create a replica cluster in distinct geographic region from the source cluster.
    """
    REPLICA = "Replica"
    """
    Create a replica cluster in the same geographic region as the source cluster.
    """


class HighAvailabilityMode(str, Enum):
    """
    The target high availability mode requested for the cluster.
    """
    DISABLED = "Disabled"
    """
    High availability mode is disabled. This mode is can see availability impact during faults or maintenance and is not recommended for production.
    """
    SAME_ZONE = "SameZone"
    """
    High availability mode is enabled, where each server in a shard is placed in the same availability zone.
    """
    ZONE_REDUNDANT_PREFERRED = "ZoneRedundantPreferred"
    """
    High availability mode is enabled and preferences ZoneRedundant if availability zones capacity is available in the region, otherwise falls-back to provisioning with SameZone.
    """


class PreviewFeature(str, Enum):
    """
    Preview features that can be enabled on a mongo cluster.
    """
    GEO_REPLICAS = "GeoReplicas"
    """
    Enables geo replicas preview feature. The feature must be set at create-time on new cluster to enable linking a geo-replica cluster to it.
    """


class PrivateEndpointServiceConnectionStatus(str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


class PublicNetworkAccess(str, Enum):
    """
    Whether or not public endpoint access is allowed for this mongo cluster.
    """
    ENABLED = "Enabled"
    """
    If set, mongo cluster can be accessed through private and public methods.
    """
    DISABLED = "Disabled"
    """
    If set, the private endpoints are the exclusive access method.
    """
