# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AdministratorPropertiesResponse',
    'BackupPropertiesResponse',
    'ComputePropertiesResponse',
    'ConnectionStringResponse',
    'FirewallRulePropertiesResponse',
    'HighAvailabilityPropertiesResponse',
    'MongoClusterPropertiesResponse',
    'PrivateEndpointConnectionPropertiesResponse',
    'PrivateEndpointConnectionResponse',
    'PrivateEndpointResponse',
    'PrivateLinkServiceConnectionStateResponse',
    'ReplicationPropertiesResponse',
    'ShardingPropertiesResponse',
    'StoragePropertiesResponse',
    'SystemDataResponse',
]

@pulumi.output_type
class AdministratorPropertiesResponse(dict):
    """
    The local administrator login properties.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "userName":
            suggest = "user_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AdministratorPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AdministratorPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AdministratorPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 user_name: Optional[str] = None):
        """
        The local administrator login properties.
        :param str user_name: The administrator user name.
        """
        if user_name is not None:
            pulumi.set(__self__, "user_name", user_name)

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> Optional[str]:
        """
        The administrator user name.
        """
        return pulumi.get(self, "user_name")


@pulumi.output_type
class BackupPropertiesResponse(dict):
    """
    The backup properties of the cluster. This includes the earliest restore time and retention settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "earliestRestoreTime":
            suggest = "earliest_restore_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BackupPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BackupPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BackupPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 earliest_restore_time: str):
        """
        The backup properties of the cluster. This includes the earliest restore time and retention settings.
        :param str earliest_restore_time: Earliest restore timestamp in UTC ISO8601 format.
        """
        pulumi.set(__self__, "earliest_restore_time", earliest_restore_time)

    @property
    @pulumi.getter(name="earliestRestoreTime")
    def earliest_restore_time(self) -> str:
        """
        Earliest restore timestamp in UTC ISO8601 format.
        """
        return pulumi.get(self, "earliest_restore_time")


@pulumi.output_type
class ComputePropertiesResponse(dict):
    """
    The compute properties of the cluster. This includes the virtual-cores/memory and scaling options applied to servers in the cluster.
    """
    def __init__(__self__, *,
                 tier: Optional[str] = None):
        """
        The compute properties of the cluster. This includes the virtual-cores/memory and scaling options applied to servers in the cluster.
        :param str tier: The compute tier to assign to the cluster, where each tier maps to a virtual-core and memory size. Example values: 'M30', 'M40'.
        """
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def tier(self) -> Optional[str]:
        """
        The compute tier to assign to the cluster, where each tier maps to a virtual-core and memory size. Example values: 'M30', 'M40'.
        """
        return pulumi.get(self, "tier")


@pulumi.output_type
class ConnectionStringResponse(dict):
    """
    Connection string for the mongo cluster
    """
    def __init__(__self__, *,
                 connection_string: str,
                 description: str,
                 name: str):
        """
        Connection string for the mongo cluster
        :param str connection_string: Value of the connection string
        :param str description: Description of the connection string
        :param str name: Name of the connection string.
        """
        pulumi.set(__self__, "connection_string", connection_string)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> str:
        """
        Value of the connection string
        """
        return pulumi.get(self, "connection_string")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Description of the connection string
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the connection string.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class FirewallRulePropertiesResponse(dict):
    """
    The properties of a mongo cluster firewall rule.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "endIpAddress":
            suggest = "end_ip_address"
        elif key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "startIpAddress":
            suggest = "start_ip_address"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FirewallRulePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FirewallRulePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FirewallRulePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 end_ip_address: str,
                 provisioning_state: str,
                 start_ip_address: str):
        """
        The properties of a mongo cluster firewall rule.
        :param str end_ip_address: The end IP address of the mongo cluster firewall rule. Must be IPv4 format.
        :param str provisioning_state: The provisioning state of the firewall rule.
        :param str start_ip_address: The start IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        pulumi.set(__self__, "end_ip_address", end_ip_address)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "start_ip_address", start_ip_address)

    @property
    @pulumi.getter(name="endIpAddress")
    def end_ip_address(self) -> str:
        """
        The end IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        return pulumi.get(self, "end_ip_address")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The provisioning state of the firewall rule.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="startIpAddress")
    def start_ip_address(self) -> str:
        """
        The start IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        return pulumi.get(self, "start_ip_address")


@pulumi.output_type
class HighAvailabilityPropertiesResponse(dict):
    """
    The high availability properties of the cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "targetMode":
            suggest = "target_mode"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in HighAvailabilityPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        HighAvailabilityPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        HighAvailabilityPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 target_mode: Optional[str] = None):
        """
        The high availability properties of the cluster.
        :param str target_mode: The target high availability mode requested for the cluster.
        """
        if target_mode is not None:
            pulumi.set(__self__, "target_mode", target_mode)

    @property
    @pulumi.getter(name="targetMode")
    def target_mode(self) -> Optional[str]:
        """
        The target high availability mode requested for the cluster.
        """
        return pulumi.get(self, "target_mode")


@pulumi.output_type
class MongoClusterPropertiesResponse(dict):
    """
    The properties of a mongo cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clusterStatus":
            suggest = "cluster_status"
        elif key == "connectionString":
            suggest = "connection_string"
        elif key == "infrastructureVersion":
            suggest = "infrastructure_version"
        elif key == "privateEndpointConnections":
            suggest = "private_endpoint_connections"
        elif key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "highAvailability":
            suggest = "high_availability"
        elif key == "previewFeatures":
            suggest = "preview_features"
        elif key == "publicNetworkAccess":
            suggest = "public_network_access"
        elif key == "serverVersion":
            suggest = "server_version"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MongoClusterPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MongoClusterPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MongoClusterPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 cluster_status: str,
                 connection_string: str,
                 infrastructure_version: str,
                 private_endpoint_connections: Sequence['outputs.PrivateEndpointConnectionResponse'],
                 provisioning_state: str,
                 replica: 'outputs.ReplicationPropertiesResponse',
                 administrator: Optional['outputs.AdministratorPropertiesResponse'] = None,
                 backup: Optional['outputs.BackupPropertiesResponse'] = None,
                 compute: Optional['outputs.ComputePropertiesResponse'] = None,
                 high_availability: Optional['outputs.HighAvailabilityPropertiesResponse'] = None,
                 preview_features: Optional[Sequence[str]] = None,
                 public_network_access: Optional[str] = None,
                 server_version: Optional[str] = None,
                 sharding: Optional['outputs.ShardingPropertiesResponse'] = None,
                 storage: Optional['outputs.StoragePropertiesResponse'] = None):
        """
        The properties of a mongo cluster.
        :param str cluster_status: The status of the mongo cluster.
        :param str connection_string: The default mongo connection string for the cluster.
        :param str infrastructure_version: The infrastructure version the cluster is provisioned on.
        :param Sequence['PrivateEndpointConnectionResponse'] private_endpoint_connections: List of private endpoint connections.
        :param str provisioning_state: The provisioning state of the mongo cluster.
        :param 'ReplicationPropertiesResponse' replica: The replication properties for the mongo cluster
        :param 'AdministratorPropertiesResponse' administrator: The local administrator properties for the mongo cluster.
        :param 'BackupPropertiesResponse' backup: The backup properties of the mongo cluster.
        :param 'ComputePropertiesResponse' compute: The compute properties of the mongo cluster.
        :param 'HighAvailabilityPropertiesResponse' high_availability: The high availability properties of the mongo cluster.
        :param Sequence[str] preview_features: List of private endpoint connections.
        :param str public_network_access: Whether or not public endpoint access is allowed for this mongo cluster.
        :param str server_version: The Mongo DB server version. Defaults to the latest available version if not specified.
        :param 'ShardingPropertiesResponse' sharding: The sharding properties of the mongo cluster.
        :param 'StoragePropertiesResponse' storage: The storage properties of the mongo cluster.
        """
        pulumi.set(__self__, "cluster_status", cluster_status)
        pulumi.set(__self__, "connection_string", connection_string)
        pulumi.set(__self__, "infrastructure_version", infrastructure_version)
        pulumi.set(__self__, "private_endpoint_connections", private_endpoint_connections)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "replica", replica)
        if administrator is not None:
            pulumi.set(__self__, "administrator", administrator)
        if backup is not None:
            pulumi.set(__self__, "backup", backup)
        if compute is not None:
            pulumi.set(__self__, "compute", compute)
        if high_availability is not None:
            pulumi.set(__self__, "high_availability", high_availability)
        if preview_features is not None:
            pulumi.set(__self__, "preview_features", preview_features)
        if public_network_access is not None:
            pulumi.set(__self__, "public_network_access", public_network_access)
        if server_version is not None:
            pulumi.set(__self__, "server_version", server_version)
        if sharding is not None:
            pulumi.set(__self__, "sharding", sharding)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)

    @property
    @pulumi.getter(name="clusterStatus")
    def cluster_status(self) -> str:
        """
        The status of the mongo cluster.
        """
        return pulumi.get(self, "cluster_status")

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> str:
        """
        The default mongo connection string for the cluster.
        """
        return pulumi.get(self, "connection_string")

    @property
    @pulumi.getter(name="infrastructureVersion")
    def infrastructure_version(self) -> str:
        """
        The infrastructure version the cluster is provisioned on.
        """
        return pulumi.get(self, "infrastructure_version")

    @property
    @pulumi.getter(name="privateEndpointConnections")
    def private_endpoint_connections(self) -> Sequence['outputs.PrivateEndpointConnectionResponse']:
        """
        List of private endpoint connections.
        """
        return pulumi.get(self, "private_endpoint_connections")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The provisioning state of the mongo cluster.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def replica(self) -> 'outputs.ReplicationPropertiesResponse':
        """
        The replication properties for the mongo cluster
        """
        return pulumi.get(self, "replica")

    @property
    @pulumi.getter
    def administrator(self) -> Optional['outputs.AdministratorPropertiesResponse']:
        """
        The local administrator properties for the mongo cluster.
        """
        return pulumi.get(self, "administrator")

    @property
    @pulumi.getter
    def backup(self) -> Optional['outputs.BackupPropertiesResponse']:
        """
        The backup properties of the mongo cluster.
        """
        return pulumi.get(self, "backup")

    @property
    @pulumi.getter
    def compute(self) -> Optional['outputs.ComputePropertiesResponse']:
        """
        The compute properties of the mongo cluster.
        """
        return pulumi.get(self, "compute")

    @property
    @pulumi.getter(name="highAvailability")
    def high_availability(self) -> Optional['outputs.HighAvailabilityPropertiesResponse']:
        """
        The high availability properties of the mongo cluster.
        """
        return pulumi.get(self, "high_availability")

    @property
    @pulumi.getter(name="previewFeatures")
    def preview_features(self) -> Optional[Sequence[str]]:
        """
        List of private endpoint connections.
        """
        return pulumi.get(self, "preview_features")

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> Optional[str]:
        """
        Whether or not public endpoint access is allowed for this mongo cluster.
        """
        return pulumi.get(self, "public_network_access")

    @property
    @pulumi.getter(name="serverVersion")
    def server_version(self) -> Optional[str]:
        """
        The Mongo DB server version. Defaults to the latest available version if not specified.
        """
        return pulumi.get(self, "server_version")

    @property
    @pulumi.getter
    def sharding(self) -> Optional['outputs.ShardingPropertiesResponse']:
        """
        The sharding properties of the mongo cluster.
        """
        return pulumi.get(self, "sharding")

    @property
    @pulumi.getter
    def storage(self) -> Optional['outputs.StoragePropertiesResponse']:
        """
        The storage properties of the mongo cluster.
        """
        return pulumi.get(self, "storage")


@pulumi.output_type
class PrivateEndpointConnectionPropertiesResponse(dict):
    """
    Properties of the private endpoint connection.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "groupIds":
            suggest = "group_ids"
        elif key == "privateLinkServiceConnectionState":
            suggest = "private_link_service_connection_state"
        elif key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "privateEndpoint":
            suggest = "private_endpoint"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PrivateEndpointConnectionPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PrivateEndpointConnectionPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PrivateEndpointConnectionPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 group_ids: Sequence[str],
                 private_link_service_connection_state: 'outputs.PrivateLinkServiceConnectionStateResponse',
                 provisioning_state: str,
                 private_endpoint: Optional['outputs.PrivateEndpointResponse'] = None):
        """
        Properties of the private endpoint connection.
        :param Sequence[str] group_ids: The group ids for the private endpoint resource.
        :param 'PrivateLinkServiceConnectionStateResponse' private_link_service_connection_state: A collection of information about the state of the connection between service consumer and provider.
        :param str provisioning_state: The provisioning state of the private endpoint connection resource.
        :param 'PrivateEndpointResponse' private_endpoint: The private endpoint resource.
        """
        pulumi.set(__self__, "group_ids", group_ids)
        pulumi.set(__self__, "private_link_service_connection_state", private_link_service_connection_state)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if private_endpoint is not None:
            pulumi.set(__self__, "private_endpoint", private_endpoint)

    @property
    @pulumi.getter(name="groupIds")
    def group_ids(self) -> Sequence[str]:
        """
        The group ids for the private endpoint resource.
        """
        return pulumi.get(self, "group_ids")

    @property
    @pulumi.getter(name="privateLinkServiceConnectionState")
    def private_link_service_connection_state(self) -> 'outputs.PrivateLinkServiceConnectionStateResponse':
        """
        A collection of information about the state of the connection between service consumer and provider.
        """
        return pulumi.get(self, "private_link_service_connection_state")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The provisioning state of the private endpoint connection resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="privateEndpoint")
    def private_endpoint(self) -> Optional['outputs.PrivateEndpointResponse']:
        """
        The private endpoint resource.
        """
        return pulumi.get(self, "private_endpoint")


@pulumi.output_type
class PrivateEndpointConnectionResponse(dict):
    """
    The private endpoint connection resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "groupIds":
            suggest = "group_ids"
        elif key == "privateLinkServiceConnectionState":
            suggest = "private_link_service_connection_state"
        elif key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "systemData":
            suggest = "system_data"
        elif key == "privateEndpoint":
            suggest = "private_endpoint"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PrivateEndpointConnectionResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PrivateEndpointConnectionResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PrivateEndpointConnectionResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 group_ids: Sequence[str],
                 id: str,
                 name: str,
                 private_link_service_connection_state: 'outputs.PrivateLinkServiceConnectionStateResponse',
                 provisioning_state: str,
                 system_data: 'outputs.SystemDataResponse',
                 type: str,
                 private_endpoint: Optional['outputs.PrivateEndpointResponse'] = None):
        """
        The private endpoint connection resource.
        :param Sequence[str] group_ids: The group ids for the private endpoint resource.
        :param str id: Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        :param str name: The name of the resource
        :param 'PrivateLinkServiceConnectionStateResponse' private_link_service_connection_state: A collection of information about the state of the connection between service consumer and provider.
        :param str provisioning_state: The provisioning state of the private endpoint connection resource.
        :param 'SystemDataResponse' system_data: Azure Resource Manager metadata containing createdBy and modifiedBy information.
        :param str type: The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        :param 'PrivateEndpointResponse' private_endpoint: The private endpoint resource.
        """
        pulumi.set(__self__, "group_ids", group_ids)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "private_link_service_connection_state", private_link_service_connection_state)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "system_data", system_data)
        pulumi.set(__self__, "type", type)
        if private_endpoint is not None:
            pulumi.set(__self__, "private_endpoint", private_endpoint)

    @property
    @pulumi.getter(name="groupIds")
    def group_ids(self) -> Sequence[str]:
        """
        The group ids for the private endpoint resource.
        """
        return pulumi.get(self, "group_ids")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateLinkServiceConnectionState")
    def private_link_service_connection_state(self) -> 'outputs.PrivateLinkServiceConnectionStateResponse':
        """
        A collection of information about the state of the connection between service consumer and provider.
        """
        return pulumi.get(self, "private_link_service_connection_state")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The provisioning state of the private endpoint connection resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="privateEndpoint")
    def private_endpoint(self) -> Optional['outputs.PrivateEndpointResponse']:
        """
        The private endpoint resource.
        """
        return pulumi.get(self, "private_endpoint")


@pulumi.output_type
class PrivateEndpointResponse(dict):
    """
    The private endpoint resource.
    """
    def __init__(__self__, *,
                 id: str):
        """
        The private endpoint resource.
        :param str id: The ARM identifier for private endpoint.
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ARM identifier for private endpoint.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class PrivateLinkServiceConnectionStateResponse(dict):
    """
    A collection of information about the state of the connection between service consumer and provider.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "actionsRequired":
            suggest = "actions_required"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PrivateLinkServiceConnectionStateResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PrivateLinkServiceConnectionStateResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PrivateLinkServiceConnectionStateResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 actions_required: Optional[str] = None,
                 description: Optional[str] = None,
                 status: Optional[str] = None):
        """
        A collection of information about the state of the connection between service consumer and provider.
        :param str actions_required: A message indicating if changes on the service provider require any updates on the consumer.
        :param str description: The reason for approval/rejection of the connection.
        :param str status: Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
        """
        if actions_required is not None:
            pulumi.set(__self__, "actions_required", actions_required)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="actionsRequired")
    def actions_required(self) -> Optional[str]:
        """
        A message indicating if changes on the service provider require any updates on the consumer.
        """
        return pulumi.get(self, "actions_required")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        The reason for approval/rejection of the connection.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ReplicationPropertiesResponse(dict):
    """
    Replica properties of the mongo cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "replicationState":
            suggest = "replication_state"
        elif key == "sourceResourceId":
            suggest = "source_resource_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ReplicationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ReplicationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ReplicationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 replication_state: str,
                 role: str,
                 source_resource_id: str):
        """
        Replica properties of the mongo cluster.
        :param str replication_state: The replication link state of the replica cluster.
        :param str role: The replication role of the cluster
        :param str source_resource_id: The resource id the source cluster for the replica cluster.
        """
        pulumi.set(__self__, "replication_state", replication_state)
        pulumi.set(__self__, "role", role)
        pulumi.set(__self__, "source_resource_id", source_resource_id)

    @property
    @pulumi.getter(name="replicationState")
    def replication_state(self) -> str:
        """
        The replication link state of the replica cluster.
        """
        return pulumi.get(self, "replication_state")

    @property
    @pulumi.getter
    def role(self) -> str:
        """
        The replication role of the cluster
        """
        return pulumi.get(self, "role")

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> str:
        """
        The resource id the source cluster for the replica cluster.
        """
        return pulumi.get(self, "source_resource_id")


@pulumi.output_type
class ShardingPropertiesResponse(dict):
    """
    The sharding properties of the cluster. This includes the shard count and scaling options for the cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "shardCount":
            suggest = "shard_count"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ShardingPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ShardingPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ShardingPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 shard_count: Optional[int] = None):
        """
        The sharding properties of the cluster. This includes the shard count and scaling options for the cluster.
        :param int shard_count: Number of shards to provision on the cluster.
        """
        if shard_count is not None:
            pulumi.set(__self__, "shard_count", shard_count)

    @property
    @pulumi.getter(name="shardCount")
    def shard_count(self) -> Optional[int]:
        """
        Number of shards to provision on the cluster.
        """
        return pulumi.get(self, "shard_count")


@pulumi.output_type
class StoragePropertiesResponse(dict):
    """
    The storage properties of the cluster. This includes the data storage size and scaling applied to servers in the cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sizeGb":
            suggest = "size_gb"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in StoragePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        StoragePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        StoragePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 size_gb: Optional[float] = None):
        """
        The storage properties of the cluster. This includes the data storage size and scaling applied to servers in the cluster.
        :param float size_gb: The size of the data disk assigned to each server.
        """
        if size_gb is not None:
            pulumi.set(__self__, "size_gb", size_gb)

    @property
    @pulumi.getter(name="sizeGb")
    def size_gb(self) -> Optional[float]:
        """
        The size of the data disk assigned to each server.
        """
        return pulumi.get(self, "size_gb")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


