# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SolutionConfigurationArgs', 'SolutionConfiguration']

@pulumi.input_type
class SolutionConfigurationArgs:
    def __init__(__self__, *,
                 resource_uri: pulumi.Input[str],
                 properties: Optional[pulumi.Input['SolutionConfigurationPropertiesArgs']] = None,
                 solution_configuration: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SolutionConfiguration resource.
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input['SolutionConfigurationPropertiesArgs'] properties: The resource-specific properties for this resource.
        :param pulumi.Input[str] solution_configuration: Represent Solution Configuration Resource.
        """
        pulumi.set(__self__, "resource_uri", resource_uri)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)
        if solution_configuration is not None:
            pulumi.set(__self__, "solution_configuration", solution_configuration)

    @property
    @pulumi.getter(name="resourceUri")
    def resource_uri(self) -> pulumi.Input[str]:
        """
        The fully qualified Azure Resource manager identifier of the resource.
        """
        return pulumi.get(self, "resource_uri")

    @resource_uri.setter
    def resource_uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_uri", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['SolutionConfigurationPropertiesArgs']]:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['SolutionConfigurationPropertiesArgs']]):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="solutionConfiguration")
    def solution_configuration(self) -> Optional[pulumi.Input[str]]:
        """
        Represent Solution Configuration Resource.
        """
        return pulumi.get(self, "solution_configuration")

    @solution_configuration.setter
    def solution_configuration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "solution_configuration", value)


class SolutionConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 properties: Optional[pulumi.Input[Union['SolutionConfigurationPropertiesArgs', 'SolutionConfigurationPropertiesArgsDict']]] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 solution_configuration: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Solution Configuration
        Azure REST API version: 2024-12-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['SolutionConfigurationPropertiesArgs', 'SolutionConfigurationPropertiesArgsDict']] properties: The resource-specific properties for this resource.
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[str] solution_configuration: Represent Solution Configuration Resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SolutionConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Solution Configuration
        Azure REST API version: 2024-12-01.

        :param str resource_name: The name of the resource.
        :param SolutionConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SolutionConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 properties: Optional[pulumi.Input[Union['SolutionConfigurationPropertiesArgs', 'SolutionConfigurationPropertiesArgsDict']]] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 solution_configuration: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SolutionConfigurationArgs.__new__(SolutionConfigurationArgs)

            __props__.__dict__["properties"] = properties
            if resource_uri is None and not opts.urn:
                raise TypeError("Missing required property 'resource_uri'")
            __props__.__dict__["resource_uri"] = resource_uri
            __props__.__dict__["solution_configuration"] = solution_configuration
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:hybridconnectivity/v20241201:SolutionConfiguration")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(SolutionConfiguration, __self__).__init__(
            'azure-native:hybridconnectivity:SolutionConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'SolutionConfiguration':
        """
        Get an existing SolutionConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = SolutionConfigurationArgs.__new__(SolutionConfigurationArgs)

        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return SolutionConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.SolutionConfigurationPropertiesResponse']:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

