# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'DiskSkuName',
    'FileShareConfigurationType',
    'ManagedResourcesNetworkAccessType',
    'ManagedServiceIdentityType',
    'NamingPatternType',
    'OSType',
    'SAPConfigurationType',
    'SAPDatabaseScaleMethod',
    'SAPDatabaseType',
    'SAPDeploymentType',
    'SAPEnvironmentType',
    'SAPHighAvailabilityType',
    'SAPProductType',
    'SAPSoftwareInstallationType',
]


class DiskSkuName(str, Enum):
    """
    Defines the disk sku name.
    """
    STANDARD_LRS = "Standard_LRS"
    """
    Standard LRS Disk SKU.
    """
    PREMIUM_LRS = "Premium_LRS"
    """
    Premium_LRS Disk SKU.
    """
    STANDARD_SS_D_LRS = "StandardSSD_LRS"
    """
    StandardSSD_LRS Disk SKU.
    """
    ULTRA_SS_D_LRS = "UltraSSD_LRS"
    """
    UltraSSD_LRS Disk SKU.
    """
    PREMIUM_ZRS = "Premium_ZRS"
    """
    Premium_ZRS Disk SKU.
    """
    STANDARD_SS_D_ZRS = "StandardSSD_ZRS"
    """
    StandardSSD_ZRS Disk SKU.
    """
    PREMIUM_V2_LRS = "PremiumV2_LRS"
    """
    PremiumV2_LRS Disk SKU.
    """


class FileShareConfigurationType(str, Enum):
    """
    The type of file share config, eg: Mount/CreateAndMount/Skip.
    """
    SKIP = "Skip"
    """
    Skip creating the file share.
    """
    CREATE_AND_MOUNT = "CreateAndMount"
    """
    Fileshare will be created and mounted by service.
    """
    MOUNT = "Mount"
    """
    Existing fileshare provided will be mounted by service.
    """


class ManagedResourcesNetworkAccessType(str, Enum):
    """
    Specifies the network access configuration for the resources that will be deployed in the Managed Resource Group. The options to choose from are Public and Private. If 'Private' is chosen, the Storage Account service tag should be enabled on the subnets in which the SAP VMs exist. This is required for establishing connectivity between VM extensions and the managed resource group storage account. This setting is currently applicable only to Storage Account. Learn more here https://go.microsoft.com/fwlink/?linkid=2247228
    """
    PUBLIC = "Public"
    """
    Managed resources will be deployed with public network access enabled.
    """
    PRIVATE = "Private"
    """
    Managed resources will be deployed with public network access disabled.
    """


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class NamingPatternType(str, Enum):
    """
    The pattern type to be used for resource naming.
    """
    FULL_RESOURCE_NAME = "FullResourceName"
    """
    Full resource names that will be created by service.
    """


class OSType(str, Enum):
    """
    The OS Type
    """
    LINUX = "Linux"
    """
    Linux OS Type.
    """
    WINDOWS = "Windows"
    """
    Windows OS Type.
    """


class SAPConfigurationType(str, Enum):
    """
    The configuration type. Eg: Deployment/Discovery
    """
    DEPLOYMENT = "Deployment"
    """
    SAP system will be deployed by service. No OS configurations will be done.
    """
    DISCOVERY = "Discovery"
    """
    Existing SAP system will be registered.
    """
    DEPLOYMENT_WITH_OS_CONFIG = "DeploymentWithOSConfig"
    """
    SAP system will be deployed by service. OS configurations will be done.
    """


class SAPDatabaseScaleMethod(str, Enum):
    """
    The DB scale method.
    """
    SCALE_UP = "ScaleUp"
    """
    ScaleUp Hana Database deployment type
    """


class SAPDatabaseType(str, Enum):
    """
    The database type.
    """
    HANA = "HANA"
    """
    HANA Database type of SAP system.
    """
    DB2 = "DB2"
    """
    DB2 database type of the SAP system.
    """


class SAPDeploymentType(str, Enum):
    """
    The deployment type. Eg: SingleServer/ThreeTier
    """
    SINGLE_SERVER = "SingleServer"
    """
    SAP Single server deployment type.
    """
    THREE_TIER = "ThreeTier"
    """
    SAP Distributed deployment type.
    """


class SAPEnvironmentType(str, Enum):
    """
    Defines the environment type - Production/Non Production.
    """
    NON_PROD = "NonProd"
    """
    Non Production SAP system.
    """
    PROD = "Prod"
    """
    Production SAP system.
    """


class SAPHighAvailabilityType(str, Enum):
    """
    The high availability type.
    """
    AVAILABILITY_SET = "AvailabilitySet"
    """
    HA deployment with availability sets.
    """
    AVAILABILITY_ZONE = "AvailabilityZone"
    """
    HA deployment with availability zones.
    """


class SAPProductType(str, Enum):
    """
    Defines the SAP Product type.
    """
    ECC = "ECC"
    """
    SAP Product ECC.
    """
    S4_HANA = "S4HANA"
    """
    SAP Product S4HANA.
    """
    OTHER = "Other"
    """
    SAP Products other than the ones listed.
    """


class SAPSoftwareInstallationType(str, Enum):
    """
    The SAP software installation type.
    """
    SERVICE_INITIATED = "ServiceInitiated"
    """
    SAP Install managed by service.
    """
    SAP_INSTALL_WITHOUT_OS_CONFIG = "SAPInstallWithoutOSConfig"
    """
    SAP Install without OS Config.
    """
    EXTERNAL = "External"
    """
    External software installation type.
    """
