# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from ... import _utilities
from ._enums import *

__all__ = [
    'ApplicationServerConfigurationArgs',
    'ApplicationServerConfigurationArgsDict',
    'ApplicationServerFullResourceNamesArgs',
    'ApplicationServerFullResourceNamesArgsDict',
    'CentralServerConfigurationArgs',
    'CentralServerConfigurationArgsDict',
    'CentralServerFullResourceNamesArgs',
    'CentralServerFullResourceNamesArgsDict',
    'CreateAndMountFileShareConfigurationArgs',
    'CreateAndMountFileShareConfigurationArgsDict',
    'DatabaseConfigurationArgs',
    'DatabaseConfigurationArgsDict',
    'DatabaseServerFullResourceNamesArgs',
    'DatabaseServerFullResourceNamesArgsDict',
    'DeployerVmPackagesArgs',
    'DeployerVmPackagesArgsDict',
    'DeploymentConfigurationArgs',
    'DeploymentConfigurationArgsDict',
    'DeploymentWithOSConfigurationArgs',
    'DeploymentWithOSConfigurationArgsDict',
    'DiscoveryConfigurationArgs',
    'DiscoveryConfigurationArgsDict',
    'DiskConfigurationArgs',
    'DiskConfigurationArgsDict',
    'DiskSkuArgs',
    'DiskSkuArgsDict',
    'DiskVolumeConfigurationArgs',
    'DiskVolumeConfigurationArgsDict',
    'ExternalInstallationSoftwareConfigurationArgs',
    'ExternalInstallationSoftwareConfigurationArgsDict',
    'HighAvailabilityConfigurationArgs',
    'HighAvailabilityConfigurationArgsDict',
    'HighAvailabilitySoftwareConfigurationArgs',
    'HighAvailabilitySoftwareConfigurationArgsDict',
    'ImageReferenceArgs',
    'ImageReferenceArgsDict',
    'LinuxConfigurationArgs',
    'LinuxConfigurationArgsDict',
    'LoadBalancerResourceNamesArgs',
    'LoadBalancerResourceNamesArgsDict',
    'ManagedRGConfigurationArgs',
    'ManagedRGConfigurationArgsDict',
    'ManagedServiceIdentityArgs',
    'ManagedServiceIdentityArgsDict',
    'MountFileShareConfigurationArgs',
    'MountFileShareConfigurationArgsDict',
    'NetworkConfigurationArgs',
    'NetworkConfigurationArgsDict',
    'NetworkInterfaceResourceNamesArgs',
    'NetworkInterfaceResourceNamesArgsDict',
    'OSProfileArgs',
    'OSProfileArgsDict',
    'OsSapConfigurationArgs',
    'OsSapConfigurationArgsDict',
    'SAPInstallWithoutOSConfigSoftwareConfigurationArgs',
    'SAPInstallWithoutOSConfigSoftwareConfigurationArgsDict',
    'ServiceInitiatedSoftwareConfigurationArgs',
    'ServiceInitiatedSoftwareConfigurationArgsDict',
    'SharedStorageResourceNamesArgs',
    'SharedStorageResourceNamesArgsDict',
    'SingleServerConfigurationArgs',
    'SingleServerConfigurationArgsDict',
    'SingleServerFullResourceNamesArgs',
    'SingleServerFullResourceNamesArgsDict',
    'SkipFileShareConfigurationArgs',
    'SkipFileShareConfigurationArgsDict',
    'SshConfigurationArgs',
    'SshConfigurationArgsDict',
    'SshKeyPairArgs',
    'SshKeyPairArgsDict',
    'SshPublicKeyArgs',
    'SshPublicKeyArgsDict',
    'StorageConfigurationArgs',
    'StorageConfigurationArgsDict',
    'ThreeTierConfigurationArgs',
    'ThreeTierConfigurationArgsDict',
    'ThreeTierFullResourceNamesArgs',
    'ThreeTierFullResourceNamesArgsDict',
    'VirtualMachineConfigurationArgs',
    'VirtualMachineConfigurationArgsDict',
    'VirtualMachineResourceNamesArgs',
    'VirtualMachineResourceNamesArgsDict',
    'WindowsConfigurationArgs',
    'WindowsConfigurationArgsDict',
]

MYPY = False

if not MYPY:
    class ApplicationServerConfigurationArgsDict(TypedDict):
        """
        Gets or sets the application server configuration.
        """
        instance_count: pulumi.Input[float]
        """
        The number of app server instances.
        """
        subnet_id: pulumi.Input[str]
        """
        The subnet id.
        """
        virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgsDict']
        """
        Gets or sets the virtual machine configuration.
        """
elif False:
    ApplicationServerConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ApplicationServerConfigurationArgs:
    def __init__(__self__, *,
                 instance_count: pulumi.Input[float],
                 subnet_id: pulumi.Input[str],
                 virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgs']):
        """
        Gets or sets the application server configuration.
        :param pulumi.Input[float] instance_count: The number of app server instances.
        :param pulumi.Input[str] subnet_id: The subnet id.
        :param pulumi.Input['VirtualMachineConfigurationArgs'] virtual_machine_configuration: Gets or sets the virtual machine configuration.
        """
        pulumi.set(__self__, "instance_count", instance_count)
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "virtual_machine_configuration", virtual_machine_configuration)

    @property
    @pulumi.getter(name="instanceCount")
    def instance_count(self) -> pulumi.Input[float]:
        """
        The number of app server instances.
        """
        return pulumi.get(self, "instance_count")

    @instance_count.setter
    def instance_count(self, value: pulumi.Input[float]):
        pulumi.set(self, "instance_count", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        The subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="virtualMachineConfiguration")
    def virtual_machine_configuration(self) -> pulumi.Input['VirtualMachineConfigurationArgs']:
        """
        Gets or sets the virtual machine configuration.
        """
        return pulumi.get(self, "virtual_machine_configuration")

    @virtual_machine_configuration.setter
    def virtual_machine_configuration(self, value: pulumi.Input['VirtualMachineConfigurationArgs']):
        pulumi.set(self, "virtual_machine_configuration", value)


if not MYPY:
    class ApplicationServerFullResourceNamesArgsDict(TypedDict):
        """
        The full resource names object for application layer resources. The number of entries in this list should be equal to the number VMs to be created for application layer.
        """
        availability_set_name: NotRequired[pulumi.Input[str]]
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-App-AvSet.
        """
        virtual_machines: NotRequired[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgsDict']]]]
        """
        The list of virtual machine naming details.
        """
elif False:
    ApplicationServerFullResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ApplicationServerFullResourceNamesArgs:
    def __init__(__self__, *,
                 availability_set_name: Optional[pulumi.Input[str]] = None,
                 virtual_machines: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]] = None):
        """
        The full resource names object for application layer resources. The number of entries in this list should be equal to the number VMs to be created for application layer.
        :param pulumi.Input[str] availability_set_name: The full name for availability set. In case name is not provided, it will be defaulted to {SID}-App-AvSet.
        :param pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]] virtual_machines: The list of virtual machine naming details.
        """
        if availability_set_name is not None:
            pulumi.set(__self__, "availability_set_name", availability_set_name)
        if virtual_machines is not None:
            pulumi.set(__self__, "virtual_machines", virtual_machines)

    @property
    @pulumi.getter(name="availabilitySetName")
    def availability_set_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-App-AvSet.
        """
        return pulumi.get(self, "availability_set_name")

    @availability_set_name.setter
    def availability_set_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_set_name", value)

    @property
    @pulumi.getter(name="virtualMachines")
    def virtual_machines(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]:
        """
        The list of virtual machine naming details.
        """
        return pulumi.get(self, "virtual_machines")

    @virtual_machines.setter
    def virtual_machines(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]):
        pulumi.set(self, "virtual_machines", value)


if not MYPY:
    class CentralServerConfigurationArgsDict(TypedDict):
        """
        Gets or sets the central server configuration.
        """
        instance_count: pulumi.Input[float]
        """
        The number of central server VMs.
        """
        subnet_id: pulumi.Input[str]
        """
        The subnet id.
        """
        virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgsDict']
        """
        Gets or sets the virtual machine configuration.
        """
elif False:
    CentralServerConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CentralServerConfigurationArgs:
    def __init__(__self__, *,
                 instance_count: pulumi.Input[float],
                 subnet_id: pulumi.Input[str],
                 virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgs']):
        """
        Gets or sets the central server configuration.
        :param pulumi.Input[float] instance_count: The number of central server VMs.
        :param pulumi.Input[str] subnet_id: The subnet id.
        :param pulumi.Input['VirtualMachineConfigurationArgs'] virtual_machine_configuration: Gets or sets the virtual machine configuration.
        """
        pulumi.set(__self__, "instance_count", instance_count)
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "virtual_machine_configuration", virtual_machine_configuration)

    @property
    @pulumi.getter(name="instanceCount")
    def instance_count(self) -> pulumi.Input[float]:
        """
        The number of central server VMs.
        """
        return pulumi.get(self, "instance_count")

    @instance_count.setter
    def instance_count(self, value: pulumi.Input[float]):
        pulumi.set(self, "instance_count", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        The subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="virtualMachineConfiguration")
    def virtual_machine_configuration(self) -> pulumi.Input['VirtualMachineConfigurationArgs']:
        """
        Gets or sets the virtual machine configuration.
        """
        return pulumi.get(self, "virtual_machine_configuration")

    @virtual_machine_configuration.setter
    def virtual_machine_configuration(self, value: pulumi.Input['VirtualMachineConfigurationArgs']):
        pulumi.set(self, "virtual_machine_configuration", value)


if not MYPY:
    class CentralServerFullResourceNamesArgsDict(TypedDict):
        """
        The full resource names object for central server layer resources.
        """
        availability_set_name: NotRequired[pulumi.Input[str]]
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-ASCS-AvSet.
        """
        load_balancer: NotRequired[pulumi.Input['LoadBalancerResourceNamesArgsDict']]
        """
        The resource names object for load balancer and related resources.
        """
        virtual_machines: NotRequired[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgsDict']]]]
        """
        The list of names for all ASCS virtual machines to be deployed. The number of entries in this list should be equal to the number VMs to be created for ASCS layer. At maximum, there can be two virtual machines at this layer: ASCS and ERS.
        """
elif False:
    CentralServerFullResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CentralServerFullResourceNamesArgs:
    def __init__(__self__, *,
                 availability_set_name: Optional[pulumi.Input[str]] = None,
                 load_balancer: Optional[pulumi.Input['LoadBalancerResourceNamesArgs']] = None,
                 virtual_machines: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]] = None):
        """
        The full resource names object for central server layer resources.
        :param pulumi.Input[str] availability_set_name: The full name for availability set. In case name is not provided, it will be defaulted to {SID}-ASCS-AvSet.
        :param pulumi.Input['LoadBalancerResourceNamesArgs'] load_balancer: The resource names object for load balancer and related resources.
        :param pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]] virtual_machines: The list of names for all ASCS virtual machines to be deployed. The number of entries in this list should be equal to the number VMs to be created for ASCS layer. At maximum, there can be two virtual machines at this layer: ASCS and ERS.
        """
        if availability_set_name is not None:
            pulumi.set(__self__, "availability_set_name", availability_set_name)
        if load_balancer is not None:
            pulumi.set(__self__, "load_balancer", load_balancer)
        if virtual_machines is not None:
            pulumi.set(__self__, "virtual_machines", virtual_machines)

    @property
    @pulumi.getter(name="availabilitySetName")
    def availability_set_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-ASCS-AvSet.
        """
        return pulumi.get(self, "availability_set_name")

    @availability_set_name.setter
    def availability_set_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_set_name", value)

    @property
    @pulumi.getter(name="loadBalancer")
    def load_balancer(self) -> Optional[pulumi.Input['LoadBalancerResourceNamesArgs']]:
        """
        The resource names object for load balancer and related resources.
        """
        return pulumi.get(self, "load_balancer")

    @load_balancer.setter
    def load_balancer(self, value: Optional[pulumi.Input['LoadBalancerResourceNamesArgs']]):
        pulumi.set(self, "load_balancer", value)

    @property
    @pulumi.getter(name="virtualMachines")
    def virtual_machines(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]:
        """
        The list of names for all ASCS virtual machines to be deployed. The number of entries in this list should be equal to the number VMs to be created for ASCS layer. At maximum, there can be two virtual machines at this layer: ASCS and ERS.
        """
        return pulumi.get(self, "virtual_machines")

    @virtual_machines.setter
    def virtual_machines(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]):
        pulumi.set(self, "virtual_machines", value)


if not MYPY:
    class CreateAndMountFileShareConfigurationArgsDict(TypedDict):
        """
        Gets or sets the file share configuration where the transport directory fileshare is created and mounted as a part of the create infra flow. Please pre-create the resource group you intend to place the transport directory in. The storage account and fileshare will be auto-created by the ACSS and doesn't need to be pre-created.
        """
        configuration_type: pulumi.Input[str]
        """
        The type of file share config.
        Expected value is 'CreateAndMount'.
        """
        resource_group: NotRequired[pulumi.Input[str]]
        """
        The name of transport file share resource group. This should be pre created by the customer. The app rg is used in case of missing input.
        """
        storage_account_name: NotRequired[pulumi.Input[str]]
        """
        The name of file share storage account name . A custom name is used in case of missing input.
        """
elif False:
    CreateAndMountFileShareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CreateAndMountFileShareConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str],
                 resource_group: Optional[pulumi.Input[str]] = None,
                 storage_account_name: Optional[pulumi.Input[str]] = None):
        """
        Gets or sets the file share configuration where the transport directory fileshare is created and mounted as a part of the create infra flow. Please pre-create the resource group you intend to place the transport directory in. The storage account and fileshare will be auto-created by the ACSS and doesn't need to be pre-created.
        :param pulumi.Input[str] configuration_type: The type of file share config.
               Expected value is 'CreateAndMount'.
        :param pulumi.Input[str] resource_group: The name of transport file share resource group. This should be pre created by the customer. The app rg is used in case of missing input.
        :param pulumi.Input[str] storage_account_name: The name of file share storage account name . A custom name is used in case of missing input.
        """
        pulumi.set(__self__, "configuration_type", 'CreateAndMount')
        if resource_group is not None:
            pulumi.set(__self__, "resource_group", resource_group)
        if storage_account_name is not None:
            pulumi.set(__self__, "storage_account_name", storage_account_name)

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The type of file share config.
        Expected value is 'CreateAndMount'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)

    @property
    @pulumi.getter(name="resourceGroup")
    def resource_group(self) -> Optional[pulumi.Input[str]]:
        """
        The name of transport file share resource group. This should be pre created by the customer. The app rg is used in case of missing input.
        """
        return pulumi.get(self, "resource_group")

    @resource_group.setter
    def resource_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_group", value)

    @property
    @pulumi.getter(name="storageAccountName")
    def storage_account_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of file share storage account name . A custom name is used in case of missing input.
        """
        return pulumi.get(self, "storage_account_name")

    @storage_account_name.setter
    def storage_account_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_account_name", value)


if not MYPY:
    class DatabaseConfigurationArgsDict(TypedDict):
        """
        Gets or sets the database configuration.
        """
        instance_count: pulumi.Input[float]
        """
        The number of database VMs.
        """
        subnet_id: pulumi.Input[str]
        """
        The subnet id.
        """
        virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgsDict']
        """
        Gets or sets the virtual machine configuration.
        """
        database_type: NotRequired[pulumi.Input[Union[str, 'SAPDatabaseType']]]
        """
        The database type.
        """
        disk_configuration: NotRequired[pulumi.Input['DiskConfigurationArgsDict']]
        """
        Gets or sets the disk configuration.
        """
elif False:
    DatabaseConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DatabaseConfigurationArgs:
    def __init__(__self__, *,
                 instance_count: pulumi.Input[float],
                 subnet_id: pulumi.Input[str],
                 virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgs'],
                 database_type: Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]] = None,
                 disk_configuration: Optional[pulumi.Input['DiskConfigurationArgs']] = None):
        """
        Gets or sets the database configuration.
        :param pulumi.Input[float] instance_count: The number of database VMs.
        :param pulumi.Input[str] subnet_id: The subnet id.
        :param pulumi.Input['VirtualMachineConfigurationArgs'] virtual_machine_configuration: Gets or sets the virtual machine configuration.
        :param pulumi.Input[Union[str, 'SAPDatabaseType']] database_type: The database type.
        :param pulumi.Input['DiskConfigurationArgs'] disk_configuration: Gets or sets the disk configuration.
        """
        pulumi.set(__self__, "instance_count", instance_count)
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "virtual_machine_configuration", virtual_machine_configuration)
        if database_type is not None:
            pulumi.set(__self__, "database_type", database_type)
        if disk_configuration is not None:
            pulumi.set(__self__, "disk_configuration", disk_configuration)

    @property
    @pulumi.getter(name="instanceCount")
    def instance_count(self) -> pulumi.Input[float]:
        """
        The number of database VMs.
        """
        return pulumi.get(self, "instance_count")

    @instance_count.setter
    def instance_count(self, value: pulumi.Input[float]):
        pulumi.set(self, "instance_count", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        The subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="virtualMachineConfiguration")
    def virtual_machine_configuration(self) -> pulumi.Input['VirtualMachineConfigurationArgs']:
        """
        Gets or sets the virtual machine configuration.
        """
        return pulumi.get(self, "virtual_machine_configuration")

    @virtual_machine_configuration.setter
    def virtual_machine_configuration(self, value: pulumi.Input['VirtualMachineConfigurationArgs']):
        pulumi.set(self, "virtual_machine_configuration", value)

    @property
    @pulumi.getter(name="databaseType")
    def database_type(self) -> Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]]:
        """
        The database type.
        """
        return pulumi.get(self, "database_type")

    @database_type.setter
    def database_type(self, value: Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]]):
        pulumi.set(self, "database_type", value)

    @property
    @pulumi.getter(name="diskConfiguration")
    def disk_configuration(self) -> Optional[pulumi.Input['DiskConfigurationArgs']]:
        """
        Gets or sets the disk configuration.
        """
        return pulumi.get(self, "disk_configuration")

    @disk_configuration.setter
    def disk_configuration(self, value: Optional[pulumi.Input['DiskConfigurationArgs']]):
        pulumi.set(self, "disk_configuration", value)


if not MYPY:
    class DatabaseServerFullResourceNamesArgsDict(TypedDict):
        """
        The full resource names object for database layer resources. The number of entries in this list should be equal to the number VMs to be created for database layer.
        """
        availability_set_name: NotRequired[pulumi.Input[str]]
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-DB-AvSet.
        """
        load_balancer: NotRequired[pulumi.Input['LoadBalancerResourceNamesArgsDict']]
        """
        The resource names object for load balancer and related resources.
        """
        virtual_machines: NotRequired[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgsDict']]]]
        """
        The list of virtual machine naming details.
        """
elif False:
    DatabaseServerFullResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DatabaseServerFullResourceNamesArgs:
    def __init__(__self__, *,
                 availability_set_name: Optional[pulumi.Input[str]] = None,
                 load_balancer: Optional[pulumi.Input['LoadBalancerResourceNamesArgs']] = None,
                 virtual_machines: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]] = None):
        """
        The full resource names object for database layer resources. The number of entries in this list should be equal to the number VMs to be created for database layer.
        :param pulumi.Input[str] availability_set_name: The full name for availability set. In case name is not provided, it will be defaulted to {SID}-DB-AvSet.
        :param pulumi.Input['LoadBalancerResourceNamesArgs'] load_balancer: The resource names object for load balancer and related resources.
        :param pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]] virtual_machines: The list of virtual machine naming details.
        """
        if availability_set_name is not None:
            pulumi.set(__self__, "availability_set_name", availability_set_name)
        if load_balancer is not None:
            pulumi.set(__self__, "load_balancer", load_balancer)
        if virtual_machines is not None:
            pulumi.set(__self__, "virtual_machines", virtual_machines)

    @property
    @pulumi.getter(name="availabilitySetName")
    def availability_set_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for availability set. In case name is not provided, it will be defaulted to {SID}-DB-AvSet.
        """
        return pulumi.get(self, "availability_set_name")

    @availability_set_name.setter
    def availability_set_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_set_name", value)

    @property
    @pulumi.getter(name="loadBalancer")
    def load_balancer(self) -> Optional[pulumi.Input['LoadBalancerResourceNamesArgs']]:
        """
        The resource names object for load balancer and related resources.
        """
        return pulumi.get(self, "load_balancer")

    @load_balancer.setter
    def load_balancer(self, value: Optional[pulumi.Input['LoadBalancerResourceNamesArgs']]):
        pulumi.set(self, "load_balancer", value)

    @property
    @pulumi.getter(name="virtualMachines")
    def virtual_machines(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]:
        """
        The list of virtual machine naming details.
        """
        return pulumi.get(self, "virtual_machines")

    @virtual_machines.setter
    def virtual_machines(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineResourceNamesArgs']]]]):
        pulumi.set(self, "virtual_machines", value)


if not MYPY:
    class DeployerVmPackagesArgsDict(TypedDict):
        """
        Defines the url and storage account ID where deployer VM packages are uploaded
        """
        storage_account_id: NotRequired[pulumi.Input[str]]
        """
        The deployer VM packages storage account id
        """
        url: NotRequired[pulumi.Input[str]]
        """
        The URL to the deployer VM packages file.
        """
elif False:
    DeployerVmPackagesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeployerVmPackagesArgs:
    def __init__(__self__, *,
                 storage_account_id: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        Defines the url and storage account ID where deployer VM packages are uploaded
        :param pulumi.Input[str] storage_account_id: The deployer VM packages storage account id
        :param pulumi.Input[str] url: The URL to the deployer VM packages file.
        """
        if storage_account_id is not None:
            pulumi.set(__self__, "storage_account_id", storage_account_id)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="storageAccountId")
    def storage_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        The deployer VM packages storage account id
        """
        return pulumi.get(self, "storage_account_id")

    @storage_account_id.setter
    def storage_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_account_id", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL to the deployer VM packages file.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


if not MYPY:
    class DeploymentConfigurationArgsDict(TypedDict):
        """
        Deployment Configuration.
        """
        configuration_type: pulumi.Input[str]
        """
        The configuration Type.
        Expected value is 'Deployment'.
        """
        app_location: NotRequired[pulumi.Input[str]]
        """
        The geo-location where the SAP system is to be created.
        """
        infrastructure_configuration: NotRequired[pulumi.Input[Union['SingleServerConfigurationArgsDict', 'ThreeTierConfigurationArgsDict']]]
        """
        The infrastructure configuration.
        """
        software_configuration: NotRequired[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgsDict', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgsDict', 'ServiceInitiatedSoftwareConfigurationArgsDict']]]
        """
        The software configuration.
        """
elif False:
    DeploymentConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str],
                 app_location: Optional[pulumi.Input[str]] = None,
                 infrastructure_configuration: Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]] = None,
                 software_configuration: Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]] = None):
        """
        Deployment Configuration.
        :param pulumi.Input[str] configuration_type: The configuration Type.
               Expected value is 'Deployment'.
        :param pulumi.Input[str] app_location: The geo-location where the SAP system is to be created.
        :param pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']] infrastructure_configuration: The infrastructure configuration.
        :param pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']] software_configuration: The software configuration.
        """
        pulumi.set(__self__, "configuration_type", 'Deployment')
        if app_location is not None:
            pulumi.set(__self__, "app_location", app_location)
        if infrastructure_configuration is not None:
            pulumi.set(__self__, "infrastructure_configuration", infrastructure_configuration)
        if software_configuration is not None:
            pulumi.set(__self__, "software_configuration", software_configuration)

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The configuration Type.
        Expected value is 'Deployment'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)

    @property
    @pulumi.getter(name="appLocation")
    def app_location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the SAP system is to be created.
        """
        return pulumi.get(self, "app_location")

    @app_location.setter
    def app_location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_location", value)

    @property
    @pulumi.getter(name="infrastructureConfiguration")
    def infrastructure_configuration(self) -> Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]]:
        """
        The infrastructure configuration.
        """
        return pulumi.get(self, "infrastructure_configuration")

    @infrastructure_configuration.setter
    def infrastructure_configuration(self, value: Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]]):
        pulumi.set(self, "infrastructure_configuration", value)

    @property
    @pulumi.getter(name="softwareConfiguration")
    def software_configuration(self) -> Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]]:
        """
        The software configuration.
        """
        return pulumi.get(self, "software_configuration")

    @software_configuration.setter
    def software_configuration(self, value: Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]]):
        pulumi.set(self, "software_configuration", value)


if not MYPY:
    class DeploymentWithOSConfigurationArgsDict(TypedDict):
        """
        Deployment along with OS Configuration.
        """
        configuration_type: pulumi.Input[str]
        """
        The configuration Type.
        Expected value is 'DeploymentWithOSConfig'.
        """
        app_location: NotRequired[pulumi.Input[str]]
        """
        The geo-location where the SAP system is to be created.
        """
        infrastructure_configuration: NotRequired[pulumi.Input[Union['SingleServerConfigurationArgsDict', 'ThreeTierConfigurationArgsDict']]]
        """
        The infrastructure configuration.
        """
        os_sap_configuration: NotRequired[pulumi.Input['OsSapConfigurationArgsDict']]
        """
        The OS and SAP configuration.
        """
        software_configuration: NotRequired[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgsDict', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgsDict', 'ServiceInitiatedSoftwareConfigurationArgsDict']]]
        """
        The software configuration.
        """
elif False:
    DeploymentWithOSConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentWithOSConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str],
                 app_location: Optional[pulumi.Input[str]] = None,
                 infrastructure_configuration: Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]] = None,
                 os_sap_configuration: Optional[pulumi.Input['OsSapConfigurationArgs']] = None,
                 software_configuration: Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]] = None):
        """
        Deployment along with OS Configuration.
        :param pulumi.Input[str] configuration_type: The configuration Type.
               Expected value is 'DeploymentWithOSConfig'.
        :param pulumi.Input[str] app_location: The geo-location where the SAP system is to be created.
        :param pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']] infrastructure_configuration: The infrastructure configuration.
        :param pulumi.Input['OsSapConfigurationArgs'] os_sap_configuration: The OS and SAP configuration.
        :param pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']] software_configuration: The software configuration.
        """
        pulumi.set(__self__, "configuration_type", 'DeploymentWithOSConfig')
        if app_location is not None:
            pulumi.set(__self__, "app_location", app_location)
        if infrastructure_configuration is not None:
            pulumi.set(__self__, "infrastructure_configuration", infrastructure_configuration)
        if os_sap_configuration is not None:
            pulumi.set(__self__, "os_sap_configuration", os_sap_configuration)
        if software_configuration is not None:
            pulumi.set(__self__, "software_configuration", software_configuration)

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The configuration Type.
        Expected value is 'DeploymentWithOSConfig'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)

    @property
    @pulumi.getter(name="appLocation")
    def app_location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the SAP system is to be created.
        """
        return pulumi.get(self, "app_location")

    @app_location.setter
    def app_location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_location", value)

    @property
    @pulumi.getter(name="infrastructureConfiguration")
    def infrastructure_configuration(self) -> Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]]:
        """
        The infrastructure configuration.
        """
        return pulumi.get(self, "infrastructure_configuration")

    @infrastructure_configuration.setter
    def infrastructure_configuration(self, value: Optional[pulumi.Input[Union['SingleServerConfigurationArgs', 'ThreeTierConfigurationArgs']]]):
        pulumi.set(self, "infrastructure_configuration", value)

    @property
    @pulumi.getter(name="osSapConfiguration")
    def os_sap_configuration(self) -> Optional[pulumi.Input['OsSapConfigurationArgs']]:
        """
        The OS and SAP configuration.
        """
        return pulumi.get(self, "os_sap_configuration")

    @os_sap_configuration.setter
    def os_sap_configuration(self, value: Optional[pulumi.Input['OsSapConfigurationArgs']]):
        pulumi.set(self, "os_sap_configuration", value)

    @property
    @pulumi.getter(name="softwareConfiguration")
    def software_configuration(self) -> Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]]:
        """
        The software configuration.
        """
        return pulumi.get(self, "software_configuration")

    @software_configuration.setter
    def software_configuration(self, value: Optional[pulumi.Input[Union['ExternalInstallationSoftwareConfigurationArgs', 'SAPInstallWithoutOSConfigSoftwareConfigurationArgs', 'ServiceInitiatedSoftwareConfigurationArgs']]]):
        pulumi.set(self, "software_configuration", value)


if not MYPY:
    class DiscoveryConfigurationArgsDict(TypedDict):
        """
        Discovery Details.
        """
        configuration_type: pulumi.Input[str]
        """
        The configuration Type.
        Expected value is 'Discovery'.
        """
        central_server_vm_id: NotRequired[pulumi.Input[str]]
        """
        The virtual machine ID of the Central Server.
        """
        managed_rg_storage_account_name: NotRequired[pulumi.Input[str]]
        """
        The custom storage account name for the storage account created by the service in the managed resource group created as part of VIS deployment.<br><br>Refer to the storage account naming rules [here](https://learn.microsoft.com/azure/azure-resource-manager/management/resource-name-rules#microsoftstorage).<br><br>If not provided, the service will create the storage account with a random name.
        """
elif False:
    DiscoveryConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DiscoveryConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str],
                 central_server_vm_id: Optional[pulumi.Input[str]] = None,
                 managed_rg_storage_account_name: Optional[pulumi.Input[str]] = None):
        """
        Discovery Details.
        :param pulumi.Input[str] configuration_type: The configuration Type.
               Expected value is 'Discovery'.
        :param pulumi.Input[str] central_server_vm_id: The virtual machine ID of the Central Server.
        :param pulumi.Input[str] managed_rg_storage_account_name: The custom storage account name for the storage account created by the service in the managed resource group created as part of VIS deployment.<br><br>Refer to the storage account naming rules [here](https://learn.microsoft.com/azure/azure-resource-manager/management/resource-name-rules#microsoftstorage).<br><br>If not provided, the service will create the storage account with a random name.
        """
        pulumi.set(__self__, "configuration_type", 'Discovery')
        if central_server_vm_id is not None:
            pulumi.set(__self__, "central_server_vm_id", central_server_vm_id)
        if managed_rg_storage_account_name is not None:
            pulumi.set(__self__, "managed_rg_storage_account_name", managed_rg_storage_account_name)

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The configuration Type.
        Expected value is 'Discovery'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)

    @property
    @pulumi.getter(name="centralServerVmId")
    def central_server_vm_id(self) -> Optional[pulumi.Input[str]]:
        """
        The virtual machine ID of the Central Server.
        """
        return pulumi.get(self, "central_server_vm_id")

    @central_server_vm_id.setter
    def central_server_vm_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "central_server_vm_id", value)

    @property
    @pulumi.getter(name="managedRgStorageAccountName")
    def managed_rg_storage_account_name(self) -> Optional[pulumi.Input[str]]:
        """
        The custom storage account name for the storage account created by the service in the managed resource group created as part of VIS deployment.<br><br>Refer to the storage account naming rules [here](https://learn.microsoft.com/azure/azure-resource-manager/management/resource-name-rules#microsoftstorage).<br><br>If not provided, the service will create the storage account with a random name.
        """
        return pulumi.get(self, "managed_rg_storage_account_name")

    @managed_rg_storage_account_name.setter
    def managed_rg_storage_account_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "managed_rg_storage_account_name", value)


if not MYPY:
    class DiskConfigurationArgsDict(TypedDict):
        """
        The Disk Configuration Details.
        """
        disk_volume_configurations: NotRequired[pulumi.Input[Mapping[str, pulumi.Input['DiskVolumeConfigurationArgsDict']]]]
        """
        The disk configuration for the db volume. For HANA, Required volumes are: ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os'], Optional volume : ['backup'].
        """
elif False:
    DiskConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DiskConfigurationArgs:
    def __init__(__self__, *,
                 disk_volume_configurations: Optional[pulumi.Input[Mapping[str, pulumi.Input['DiskVolumeConfigurationArgs']]]] = None):
        """
        The Disk Configuration Details.
        :param pulumi.Input[Mapping[str, pulumi.Input['DiskVolumeConfigurationArgs']]] disk_volume_configurations: The disk configuration for the db volume. For HANA, Required volumes are: ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os'], Optional volume : ['backup'].
        """
        if disk_volume_configurations is not None:
            pulumi.set(__self__, "disk_volume_configurations", disk_volume_configurations)

    @property
    @pulumi.getter(name="diskVolumeConfigurations")
    def disk_volume_configurations(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['DiskVolumeConfigurationArgs']]]]:
        """
        The disk configuration for the db volume. For HANA, Required volumes are: ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os'], Optional volume : ['backup'].
        """
        return pulumi.get(self, "disk_volume_configurations")

    @disk_volume_configurations.setter
    def disk_volume_configurations(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['DiskVolumeConfigurationArgs']]]]):
        pulumi.set(self, "disk_volume_configurations", value)


if not MYPY:
    class DiskSkuArgsDict(TypedDict):
        """
        The type of disk sku. For example, Standard_LRS, Standard_ZRS, Premium_LRS, Premium_ZRS.
        """
        name: NotRequired[pulumi.Input[Union[str, 'DiskSkuName']]]
        """
        Defines the disk sku name.
        """
elif False:
    DiskSkuArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DiskSkuArgs:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[Union[str, 'DiskSkuName']]] = None):
        """
        The type of disk sku. For example, Standard_LRS, Standard_ZRS, Premium_LRS, Premium_ZRS.
        :param pulumi.Input[Union[str, 'DiskSkuName']] name: Defines the disk sku name.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[Union[str, 'DiskSkuName']]]:
        """
        Defines the disk sku name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[Union[str, 'DiskSkuName']]]):
        pulumi.set(self, "name", value)


if not MYPY:
    class DiskVolumeConfigurationArgsDict(TypedDict):
        """
        The disk configuration required for the selected volume.
        """
        count: NotRequired[pulumi.Input[float]]
        """
        The total number of disks required for the concerned volume.
        """
        size_gb: NotRequired[pulumi.Input[float]]
        """
        The disk size in GB.
        """
        sku: NotRequired[pulumi.Input['DiskSkuArgsDict']]
        """
        The disk SKU details.
        """
elif False:
    DiskVolumeConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DiskVolumeConfigurationArgs:
    def __init__(__self__, *,
                 count: Optional[pulumi.Input[float]] = None,
                 size_gb: Optional[pulumi.Input[float]] = None,
                 sku: Optional[pulumi.Input['DiskSkuArgs']] = None):
        """
        The disk configuration required for the selected volume.
        :param pulumi.Input[float] count: The total number of disks required for the concerned volume.
        :param pulumi.Input[float] size_gb: The disk size in GB.
        :param pulumi.Input['DiskSkuArgs'] sku: The disk SKU details.
        """
        if count is not None:
            pulumi.set(__self__, "count", count)
        if size_gb is not None:
            pulumi.set(__self__, "size_gb", size_gb)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)

    @property
    @pulumi.getter
    def count(self) -> Optional[pulumi.Input[float]]:
        """
        The total number of disks required for the concerned volume.
        """
        return pulumi.get(self, "count")

    @count.setter
    def count(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "count", value)

    @property
    @pulumi.getter(name="sizeGB")
    def size_gb(self) -> Optional[pulumi.Input[float]]:
        """
        The disk size in GB.
        """
        return pulumi.get(self, "size_gb")

    @size_gb.setter
    def size_gb(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "size_gb", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input['DiskSkuArgs']]:
        """
        The disk SKU details.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input['DiskSkuArgs']]):
        pulumi.set(self, "sku", value)


if not MYPY:
    class ExternalInstallationSoftwareConfigurationArgsDict(TypedDict):
        """
        The SAP Software configuration Input when the software is installed externally outside the service.
        """
        software_installation_type: pulumi.Input[str]
        """
        The SAP software installation Type.
        Expected value is 'External'.
        """
        central_server_vm_id: NotRequired[pulumi.Input[str]]
        """
        The resource ID of the virtual machine containing the central server instance.
        """
elif False:
    ExternalInstallationSoftwareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ExternalInstallationSoftwareConfigurationArgs:
    def __init__(__self__, *,
                 software_installation_type: pulumi.Input[str],
                 central_server_vm_id: Optional[pulumi.Input[str]] = None):
        """
        The SAP Software configuration Input when the software is installed externally outside the service.
        :param pulumi.Input[str] software_installation_type: The SAP software installation Type.
               Expected value is 'External'.
        :param pulumi.Input[str] central_server_vm_id: The resource ID of the virtual machine containing the central server instance.
        """
        pulumi.set(__self__, "software_installation_type", 'External')
        if central_server_vm_id is not None:
            pulumi.set(__self__, "central_server_vm_id", central_server_vm_id)

    @property
    @pulumi.getter(name="softwareInstallationType")
    def software_installation_type(self) -> pulumi.Input[str]:
        """
        The SAP software installation Type.
        Expected value is 'External'.
        """
        return pulumi.get(self, "software_installation_type")

    @software_installation_type.setter
    def software_installation_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "software_installation_type", value)

    @property
    @pulumi.getter(name="centralServerVmId")
    def central_server_vm_id(self) -> Optional[pulumi.Input[str]]:
        """
        The resource ID of the virtual machine containing the central server instance.
        """
        return pulumi.get(self, "central_server_vm_id")

    @central_server_vm_id.setter
    def central_server_vm_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "central_server_vm_id", value)


if not MYPY:
    class HighAvailabilityConfigurationArgsDict(TypedDict):
        """
        Gets or sets the high availability configuration.
        """
        high_availability_type: pulumi.Input[Union[str, 'SAPHighAvailabilityType']]
        """
        The high availability type.
        """
elif False:
    HighAvailabilityConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class HighAvailabilityConfigurationArgs:
    def __init__(__self__, *,
                 high_availability_type: pulumi.Input[Union[str, 'SAPHighAvailabilityType']]):
        """
        Gets or sets the high availability configuration.
        :param pulumi.Input[Union[str, 'SAPHighAvailabilityType']] high_availability_type: The high availability type.
        """
        pulumi.set(__self__, "high_availability_type", high_availability_type)

    @property
    @pulumi.getter(name="highAvailabilityType")
    def high_availability_type(self) -> pulumi.Input[Union[str, 'SAPHighAvailabilityType']]:
        """
        The high availability type.
        """
        return pulumi.get(self, "high_availability_type")

    @high_availability_type.setter
    def high_availability_type(self, value: pulumi.Input[Union[str, 'SAPHighAvailabilityType']]):
        pulumi.set(self, "high_availability_type", value)


if not MYPY:
    class HighAvailabilitySoftwareConfigurationArgsDict(TypedDict):
        """
        Gets or sets the HA software configuration.
        """
        fencing_client_id: pulumi.Input[str]
        """
        The fencing client id.
        """
        fencing_client_password: pulumi.Input[str]
        """
        The fencing client id secret/password. The secret should never expire. This will be used pacemaker to start/stop the cluster VMs.
        """
elif False:
    HighAvailabilitySoftwareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class HighAvailabilitySoftwareConfigurationArgs:
    def __init__(__self__, *,
                 fencing_client_id: pulumi.Input[str],
                 fencing_client_password: pulumi.Input[str]):
        """
        Gets or sets the HA software configuration.
        :param pulumi.Input[str] fencing_client_id: The fencing client id.
        :param pulumi.Input[str] fencing_client_password: The fencing client id secret/password. The secret should never expire. This will be used pacemaker to start/stop the cluster VMs.
        """
        pulumi.set(__self__, "fencing_client_id", fencing_client_id)
        pulumi.set(__self__, "fencing_client_password", fencing_client_password)

    @property
    @pulumi.getter(name="fencingClientId")
    def fencing_client_id(self) -> pulumi.Input[str]:
        """
        The fencing client id.
        """
        return pulumi.get(self, "fencing_client_id")

    @fencing_client_id.setter
    def fencing_client_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "fencing_client_id", value)

    @property
    @pulumi.getter(name="fencingClientPassword")
    def fencing_client_password(self) -> pulumi.Input[str]:
        """
        The fencing client id secret/password. The secret should never expire. This will be used pacemaker to start/stop the cluster VMs.
        """
        return pulumi.get(self, "fencing_client_password")

    @fencing_client_password.setter
    def fencing_client_password(self, value: pulumi.Input[str]):
        pulumi.set(self, "fencing_client_password", value)


if not MYPY:
    class ImageReferenceArgsDict(TypedDict):
        """
        Specifies information about the image to use. You can specify information about platform images, marketplace images, or virtual machine images. This element is required when you want to use a platform image, marketplace image, or virtual machine image, but is not used in other creation operations. NOTE: Image reference publisher and offer can only be set when you create the scale set.
        """
        id: NotRequired[pulumi.Input[str]]
        """
        Specifies the ARM resource ID of the Azure Compute Gallery image version used for creating ACSS VMs. You will need to provide this input when you choose to deploy virtual machines in ACSS with OS image from the Azure Compute gallery.
        """
        offer: NotRequired[pulumi.Input[str]]
        """
        Specifies the offer of the platform image or marketplace image used to create the virtual machine.
        """
        publisher: NotRequired[pulumi.Input[str]]
        """
        The image publisher.
        """
        sku: NotRequired[pulumi.Input[str]]
        """
        The image SKU.
        """
        version: NotRequired[pulumi.Input[str]]
        """
        Specifies the version of the platform image or marketplace image used to create the virtual machine. The allowed formats are Major.Minor.Build or 'latest'. Major, Minor, and Build are decimal numbers. Specify 'latest' to use the latest version of an image available at deploy time. Even if you use 'latest', the VM image will not automatically update after deploy time even if a new version becomes available.
        """
elif False:
    ImageReferenceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ImageReferenceArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[str]] = None,
                 offer: Optional[pulumi.Input[str]] = None,
                 publisher: Optional[pulumi.Input[str]] = None,
                 sku: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None):
        """
        Specifies information about the image to use. You can specify information about platform images, marketplace images, or virtual machine images. This element is required when you want to use a platform image, marketplace image, or virtual machine image, but is not used in other creation operations. NOTE: Image reference publisher and offer can only be set when you create the scale set.
        :param pulumi.Input[str] id: Specifies the ARM resource ID of the Azure Compute Gallery image version used for creating ACSS VMs. You will need to provide this input when you choose to deploy virtual machines in ACSS with OS image from the Azure Compute gallery.
        :param pulumi.Input[str] offer: Specifies the offer of the platform image or marketplace image used to create the virtual machine.
        :param pulumi.Input[str] publisher: The image publisher.
        :param pulumi.Input[str] sku: The image SKU.
        :param pulumi.Input[str] version: Specifies the version of the platform image or marketplace image used to create the virtual machine. The allowed formats are Major.Minor.Build or 'latest'. Major, Minor, and Build are decimal numbers. Specify 'latest' to use the latest version of an image available at deploy time. Even if you use 'latest', the VM image will not automatically update after deploy time even if a new version becomes available.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)
        if offer is not None:
            pulumi.set(__self__, "offer", offer)
        if publisher is not None:
            pulumi.set(__self__, "publisher", publisher)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ARM resource ID of the Azure Compute Gallery image version used for creating ACSS VMs. You will need to provide this input when you choose to deploy virtual machines in ACSS with OS image from the Azure Compute gallery.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def offer(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the offer of the platform image or marketplace image used to create the virtual machine.
        """
        return pulumi.get(self, "offer")

    @offer.setter
    def offer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "offer", value)

    @property
    @pulumi.getter
    def publisher(self) -> Optional[pulumi.Input[str]]:
        """
        The image publisher.
        """
        return pulumi.get(self, "publisher")

    @publisher.setter
    def publisher(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "publisher", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input[str]]:
        """
        The image SKU.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the version of the platform image or marketplace image used to create the virtual machine. The allowed formats are Major.Minor.Build or 'latest'. Major, Minor, and Build are decimal numbers. Specify 'latest' to use the latest version of an image available at deploy time. Even if you use 'latest', the VM image will not automatically update after deploy time even if a new version becomes available.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)


if not MYPY:
    class LinuxConfigurationArgsDict(TypedDict):
        """
        Specifies the Linux operating system settings on the virtual machine. <br><br>For a list of supported Linux distributions, see [Linux on Azure-Endorsed Distributions](https://docs.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
        """
        os_type: pulumi.Input[str]
        """
        The OS Type
        Expected value is 'Linux'.
        """
        disable_password_authentication: NotRequired[pulumi.Input[bool]]
        """
        Specifies whether password authentication should be disabled.
        """
        ssh: NotRequired[pulumi.Input['SshConfigurationArgsDict']]
        """
        Specifies the ssh key configuration for a Linux OS. (This property is deprecated, please use 'sshKeyPair' instead)
        """
        ssh_key_pair: NotRequired[pulumi.Input['SshKeyPairArgsDict']]
        """
        The SSH Key-pair used to authenticate with the VM's.
        """
elif False:
    LinuxConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LinuxConfigurationArgs:
    def __init__(__self__, *,
                 os_type: pulumi.Input[str],
                 disable_password_authentication: Optional[pulumi.Input[bool]] = None,
                 ssh: Optional[pulumi.Input['SshConfigurationArgs']] = None,
                 ssh_key_pair: Optional[pulumi.Input['SshKeyPairArgs']] = None):
        """
        Specifies the Linux operating system settings on the virtual machine. <br><br>For a list of supported Linux distributions, see [Linux on Azure-Endorsed Distributions](https://docs.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
        :param pulumi.Input[str] os_type: The OS Type
               Expected value is 'Linux'.
        :param pulumi.Input[bool] disable_password_authentication: Specifies whether password authentication should be disabled.
        :param pulumi.Input['SshConfigurationArgs'] ssh: Specifies the ssh key configuration for a Linux OS. (This property is deprecated, please use 'sshKeyPair' instead)
        :param pulumi.Input['SshKeyPairArgs'] ssh_key_pair: The SSH Key-pair used to authenticate with the VM's.
        """
        pulumi.set(__self__, "os_type", 'Linux')
        if disable_password_authentication is not None:
            pulumi.set(__self__, "disable_password_authentication", disable_password_authentication)
        if ssh is not None:
            pulumi.set(__self__, "ssh", ssh)
        if ssh_key_pair is not None:
            pulumi.set(__self__, "ssh_key_pair", ssh_key_pair)

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> pulumi.Input[str]:
        """
        The OS Type
        Expected value is 'Linux'.
        """
        return pulumi.get(self, "os_type")

    @os_type.setter
    def os_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "os_type", value)

    @property
    @pulumi.getter(name="disablePasswordAuthentication")
    def disable_password_authentication(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether password authentication should be disabled.
        """
        return pulumi.get(self, "disable_password_authentication")

    @disable_password_authentication.setter
    def disable_password_authentication(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "disable_password_authentication", value)

    @property
    @pulumi.getter
    def ssh(self) -> Optional[pulumi.Input['SshConfigurationArgs']]:
        """
        Specifies the ssh key configuration for a Linux OS. (This property is deprecated, please use 'sshKeyPair' instead)
        """
        return pulumi.get(self, "ssh")

    @ssh.setter
    def ssh(self, value: Optional[pulumi.Input['SshConfigurationArgs']]):
        pulumi.set(self, "ssh", value)

    @property
    @pulumi.getter(name="sshKeyPair")
    def ssh_key_pair(self) -> Optional[pulumi.Input['SshKeyPairArgs']]:
        """
        The SSH Key-pair used to authenticate with the VM's.
        """
        return pulumi.get(self, "ssh_key_pair")

    @ssh_key_pair.setter
    def ssh_key_pair(self, value: Optional[pulumi.Input['SshKeyPairArgs']]):
        pulumi.set(self, "ssh_key_pair", value)


if not MYPY:
    class LoadBalancerResourceNamesArgsDict(TypedDict):
        """
        The resource names object for load balancer and related resources.
        """
        backend_pool_names: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The list of backend pool names. Currently, ACSS deploys only one backend pool and hence, size of this list should be 1
        """
        frontend_ip_configuration_names: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The list of frontend IP configuration names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        """
        health_probe_names: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The list of health probe names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        """
        load_balancer_name: NotRequired[pulumi.Input[str]]
        """
        The full resource name for load balancer. If this value is not provided, load balancer will be name as {ASCS/DB}-loadBalancer.
        """
elif False:
    LoadBalancerResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LoadBalancerResourceNamesArgs:
    def __init__(__self__, *,
                 backend_pool_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 frontend_ip_configuration_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 health_probe_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 load_balancer_name: Optional[pulumi.Input[str]] = None):
        """
        The resource names object for load balancer and related resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backend_pool_names: The list of backend pool names. Currently, ACSS deploys only one backend pool and hence, size of this list should be 1
        :param pulumi.Input[Sequence[pulumi.Input[str]]] frontend_ip_configuration_names: The list of frontend IP configuration names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] health_probe_names: The list of health probe names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        :param pulumi.Input[str] load_balancer_name: The full resource name for load balancer. If this value is not provided, load balancer will be name as {ASCS/DB}-loadBalancer.
        """
        if backend_pool_names is not None:
            pulumi.set(__self__, "backend_pool_names", backend_pool_names)
        if frontend_ip_configuration_names is not None:
            pulumi.set(__self__, "frontend_ip_configuration_names", frontend_ip_configuration_names)
        if health_probe_names is not None:
            pulumi.set(__self__, "health_probe_names", health_probe_names)
        if load_balancer_name is not None:
            pulumi.set(__self__, "load_balancer_name", load_balancer_name)

    @property
    @pulumi.getter(name="backendPoolNames")
    def backend_pool_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of backend pool names. Currently, ACSS deploys only one backend pool and hence, size of this list should be 1
        """
        return pulumi.get(self, "backend_pool_names")

    @backend_pool_names.setter
    def backend_pool_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "backend_pool_names", value)

    @property
    @pulumi.getter(name="frontendIpConfigurationNames")
    def frontend_ip_configuration_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of frontend IP configuration names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        """
        return pulumi.get(self, "frontend_ip_configuration_names")

    @frontend_ip_configuration_names.setter
    def frontend_ip_configuration_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "frontend_ip_configuration_names", value)

    @property
    @pulumi.getter(name="healthProbeNames")
    def health_probe_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of health probe names. If provided as input, size of this list should be 2 for cs layer and should be 1 for database layer.
        """
        return pulumi.get(self, "health_probe_names")

    @health_probe_names.setter
    def health_probe_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "health_probe_names", value)

    @property
    @pulumi.getter(name="loadBalancerName")
    def load_balancer_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full resource name for load balancer. If this value is not provided, load balancer will be name as {ASCS/DB}-loadBalancer.
        """
        return pulumi.get(self, "load_balancer_name")

    @load_balancer_name.setter
    def load_balancer_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "load_balancer_name", value)


if not MYPY:
    class ManagedRGConfigurationArgsDict(TypedDict):
        """
        Managed resource group configuration
        """
        name: NotRequired[pulumi.Input[str]]
        """
        Managed resource group name
        """
elif False:
    ManagedRGConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ManagedRGConfigurationArgs:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Managed resource group configuration
        :param pulumi.Input[str] name: Managed resource group name
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Managed resource group name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


if not MYPY:
    class ManagedServiceIdentityArgsDict(TypedDict):
        """
        Managed service identity (system assigned and/or user assigned identities)
        """
        type: pulumi.Input[Union[str, 'ManagedServiceIdentityType']]
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        user_assigned_identities: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
elif False:
    ManagedServiceIdentityArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ManagedServiceIdentityArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[Union[str, 'ManagedServiceIdentityType']],
                 user_assigned_identities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Managed service identity (system assigned and/or user assigned identities)
        :param pulumi.Input[Union[str, 'ManagedServiceIdentityType']] type: Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        :param pulumi.Input[Sequence[pulumi.Input[str]]] user_assigned_identities: The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        pulumi.set(__self__, "type", type)
        if user_assigned_identities is not None:
            pulumi.set(__self__, "user_assigned_identities", user_assigned_identities)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[Union[str, 'ManagedServiceIdentityType']]:
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[Union[str, 'ManagedServiceIdentityType']]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="userAssignedIdentities")
    def user_assigned_identities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        return pulumi.get(self, "user_assigned_identities")

    @user_assigned_identities.setter
    def user_assigned_identities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "user_assigned_identities", value)


if not MYPY:
    class MountFileShareConfigurationArgsDict(TypedDict):
        """
        Gets or sets the file share configuration where the transport directory fileshare already exists, and user wishes to mount the fileshare as a part of the create infra flow.
        """
        configuration_type: pulumi.Input[str]
        """
        The type of file share config.
        Expected value is 'Mount'.
        """
        id: pulumi.Input[str]
        """
        The fileshare resource ID
        """
        private_endpoint_id: pulumi.Input[str]
        """
        The private endpoint resource ID
        """
elif False:
    MountFileShareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MountFileShareConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str],
                 id: pulumi.Input[str],
                 private_endpoint_id: pulumi.Input[str]):
        """
        Gets or sets the file share configuration where the transport directory fileshare already exists, and user wishes to mount the fileshare as a part of the create infra flow.
        :param pulumi.Input[str] configuration_type: The type of file share config.
               Expected value is 'Mount'.
        :param pulumi.Input[str] id: The fileshare resource ID
        :param pulumi.Input[str] private_endpoint_id: The private endpoint resource ID
        """
        pulumi.set(__self__, "configuration_type", 'Mount')
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "private_endpoint_id", private_endpoint_id)

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The type of file share config.
        Expected value is 'Mount'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[str]:
        """
        The fileshare resource ID
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="privateEndpointId")
    def private_endpoint_id(self) -> pulumi.Input[str]:
        """
        The private endpoint resource ID
        """
        return pulumi.get(self, "private_endpoint_id")

    @private_endpoint_id.setter
    def private_endpoint_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "private_endpoint_id", value)


if not MYPY:
    class NetworkConfigurationArgsDict(TypedDict):
        """
        Defines the network configuration type for SAP system infrastructure that is being deployed
        """
        is_secondary_ip_enabled: NotRequired[pulumi.Input[bool]]
        """
        Specifies whether a secondary IP address should be added to the network interface on all VMs of the SAP system being deployed
        """
elif False:
    NetworkConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class NetworkConfigurationArgs:
    def __init__(__self__, *,
                 is_secondary_ip_enabled: Optional[pulumi.Input[bool]] = None):
        """
        Defines the network configuration type for SAP system infrastructure that is being deployed
        :param pulumi.Input[bool] is_secondary_ip_enabled: Specifies whether a secondary IP address should be added to the network interface on all VMs of the SAP system being deployed
        """
        if is_secondary_ip_enabled is None:
            is_secondary_ip_enabled = False
        if is_secondary_ip_enabled is not None:
            pulumi.set(__self__, "is_secondary_ip_enabled", is_secondary_ip_enabled)

    @property
    @pulumi.getter(name="isSecondaryIpEnabled")
    def is_secondary_ip_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether a secondary IP address should be added to the network interface on all VMs of the SAP system being deployed
        """
        return pulumi.get(self, "is_secondary_ip_enabled")

    @is_secondary_ip_enabled.setter
    def is_secondary_ip_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_secondary_ip_enabled", value)


if not MYPY:
    class NetworkInterfaceResourceNamesArgsDict(TypedDict):
        """
        The resource names object for network interface and related resources.
        """
        network_interface_name: NotRequired[pulumi.Input[str]]
        """
        The full name for network interface. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}-Nic. In case of HA-AvZone systems, default name will be {SID}-{App/ASCS/DB}-Zone{A/B}-Nic with an incrementor at the end in case of more than 1 instance per layer. For distributed and HA-AvSet systems, default name will be {SID}-{App/ASCS/DB}-Nic with an incrementor at the end in case of more than 1 instance per layer.
        """
elif False:
    NetworkInterfaceResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class NetworkInterfaceResourceNamesArgs:
    def __init__(__self__, *,
                 network_interface_name: Optional[pulumi.Input[str]] = None):
        """
        The resource names object for network interface and related resources.
        :param pulumi.Input[str] network_interface_name: The full name for network interface. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}-Nic. In case of HA-AvZone systems, default name will be {SID}-{App/ASCS/DB}-Zone{A/B}-Nic with an incrementor at the end in case of more than 1 instance per layer. For distributed and HA-AvSet systems, default name will be {SID}-{App/ASCS/DB}-Nic with an incrementor at the end in case of more than 1 instance per layer.
        """
        if network_interface_name is not None:
            pulumi.set(__self__, "network_interface_name", network_interface_name)

    @property
    @pulumi.getter(name="networkInterfaceName")
    def network_interface_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for network interface. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}-Nic. In case of HA-AvZone systems, default name will be {SID}-{App/ASCS/DB}-Zone{A/B}-Nic with an incrementor at the end in case of more than 1 instance per layer. For distributed and HA-AvSet systems, default name will be {SID}-{App/ASCS/DB}-Nic with an incrementor at the end in case of more than 1 instance per layer.
        """
        return pulumi.get(self, "network_interface_name")

    @network_interface_name.setter
    def network_interface_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_interface_name", value)


if not MYPY:
    class OSProfileArgsDict(TypedDict):
        """
        Specifies the operating system settings for the virtual machine. Some of the settings cannot be changed once VM is provisioned.
        """
        admin_password: NotRequired[pulumi.Input[str]]
        """
        Specifies the password of the administrator account. <br><br> **Minimum-length (Windows):** 8 characters <br><br> **Minimum-length (Linux):** 6 characters <br><br> **Max-length (Windows):** 123 characters <br><br> **Max-length (Linux):** 72 characters <br><br> **Complexity requirements:** 3 out of 4 conditions below need to be fulfilled <br> Has lower characters <br>Has upper characters <br> Has a digit <br> Has a special character (Regex match [\\W_]) <br><br> **Disallowed values:** "abc@123", "P@$$w0rd", "P@ssw0rd", "P@ssword123", "Pa$$word", "pass@word1", "Password!", "Password1", "Password22", "iloveyou!" <br><br> For resetting the password, see [How to reset the Remote Desktop service or its login password in a Windows VM](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/reset-rdp) <br><br> For resetting root password, see [Manage users, SSH, and check or repair disks on Azure Linux VMs using the VMAccess Extension](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/troubleshoot-ssh-connection)
        """
        admin_username: NotRequired[pulumi.Input[str]]
        """
        Specifies the name of the administrator account. <br><br> This property cannot be updated after the VM is created. <br><br> **Windows-only restriction:** Cannot end in "." <br><br> **Disallowed values:** "administrator", "admin", "user", "user1", "test", "user2", "test1", "user3", "admin1", "1", "123", "a", "actuser", "adm", "admin2", "aspnet", "backup", "console", "david", "guest", "john", "owner", "root", "server", "sql", "support", "support_388945a0", "sys", "test2", "test3", "user4", "user5". <br><br> **Minimum-length (Linux):** 1  character <br><br> **Max-length (Linux):** 64 characters <br><br> **Max-length (Windows):** 20 characters.
        """
        os_configuration: NotRequired[pulumi.Input[Union['LinuxConfigurationArgsDict', 'WindowsConfigurationArgsDict']]]
        """
        Specifies Windows operating system settings on the virtual machine.
        """
elif False:
    OSProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OSProfileArgs:
    def __init__(__self__, *,
                 admin_password: Optional[pulumi.Input[str]] = None,
                 admin_username: Optional[pulumi.Input[str]] = None,
                 os_configuration: Optional[pulumi.Input[Union['LinuxConfigurationArgs', 'WindowsConfigurationArgs']]] = None):
        """
        Specifies the operating system settings for the virtual machine. Some of the settings cannot be changed once VM is provisioned.
        :param pulumi.Input[str] admin_password: Specifies the password of the administrator account. <br><br> **Minimum-length (Windows):** 8 characters <br><br> **Minimum-length (Linux):** 6 characters <br><br> **Max-length (Windows):** 123 characters <br><br> **Max-length (Linux):** 72 characters <br><br> **Complexity requirements:** 3 out of 4 conditions below need to be fulfilled <br> Has lower characters <br>Has upper characters <br> Has a digit <br> Has a special character (Regex match [\\W_]) <br><br> **Disallowed values:** "abc@123", "P@$$w0rd", "P@ssw0rd", "P@ssword123", "Pa$$word", "pass@word1", "Password!", "Password1", "Password22", "iloveyou!" <br><br> For resetting the password, see [How to reset the Remote Desktop service or its login password in a Windows VM](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/reset-rdp) <br><br> For resetting root password, see [Manage users, SSH, and check or repair disks on Azure Linux VMs using the VMAccess Extension](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/troubleshoot-ssh-connection)
        :param pulumi.Input[str] admin_username: Specifies the name of the administrator account. <br><br> This property cannot be updated after the VM is created. <br><br> **Windows-only restriction:** Cannot end in "." <br><br> **Disallowed values:** "administrator", "admin", "user", "user1", "test", "user2", "test1", "user3", "admin1", "1", "123", "a", "actuser", "adm", "admin2", "aspnet", "backup", "console", "david", "guest", "john", "owner", "root", "server", "sql", "support", "support_388945a0", "sys", "test2", "test3", "user4", "user5". <br><br> **Minimum-length (Linux):** 1  character <br><br> **Max-length (Linux):** 64 characters <br><br> **Max-length (Windows):** 20 characters.
        :param pulumi.Input[Union['LinuxConfigurationArgs', 'WindowsConfigurationArgs']] os_configuration: Specifies Windows operating system settings on the virtual machine.
        """
        if admin_password is not None:
            pulumi.set(__self__, "admin_password", admin_password)
        if admin_username is not None:
            pulumi.set(__self__, "admin_username", admin_username)
        if os_configuration is not None:
            pulumi.set(__self__, "os_configuration", os_configuration)

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the password of the administrator account. <br><br> **Minimum-length (Windows):** 8 characters <br><br> **Minimum-length (Linux):** 6 characters <br><br> **Max-length (Windows):** 123 characters <br><br> **Max-length (Linux):** 72 characters <br><br> **Complexity requirements:** 3 out of 4 conditions below need to be fulfilled <br> Has lower characters <br>Has upper characters <br> Has a digit <br> Has a special character (Regex match [\\W_]) <br><br> **Disallowed values:** "abc@123", "P@$$w0rd", "P@ssw0rd", "P@ssword123", "Pa$$word", "pass@word1", "Password!", "Password1", "Password22", "iloveyou!" <br><br> For resetting the password, see [How to reset the Remote Desktop service or its login password in a Windows VM](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/reset-rdp) <br><br> For resetting root password, see [Manage users, SSH, and check or repair disks on Azure Linux VMs using the VMAccess Extension](https://docs.microsoft.com/troubleshoot/azure/virtual-machines/troubleshoot-ssh-connection)
        """
        return pulumi.get(self, "admin_password")

    @admin_password.setter
    def admin_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_password", value)

    @property
    @pulumi.getter(name="adminUsername")
    def admin_username(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the administrator account. <br><br> This property cannot be updated after the VM is created. <br><br> **Windows-only restriction:** Cannot end in "." <br><br> **Disallowed values:** "administrator", "admin", "user", "user1", "test", "user2", "test1", "user3", "admin1", "1", "123", "a", "actuser", "adm", "admin2", "aspnet", "backup", "console", "david", "guest", "john", "owner", "root", "server", "sql", "support", "support_388945a0", "sys", "test2", "test3", "user4", "user5". <br><br> **Minimum-length (Linux):** 1  character <br><br> **Max-length (Linux):** 64 characters <br><br> **Max-length (Windows):** 20 characters.
        """
        return pulumi.get(self, "admin_username")

    @admin_username.setter
    def admin_username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_username", value)

    @property
    @pulumi.getter(name="osConfiguration")
    def os_configuration(self) -> Optional[pulumi.Input[Union['LinuxConfigurationArgs', 'WindowsConfigurationArgs']]]:
        """
        Specifies Windows operating system settings on the virtual machine.
        """
        return pulumi.get(self, "os_configuration")

    @os_configuration.setter
    def os_configuration(self, value: Optional[pulumi.Input[Union['LinuxConfigurationArgs', 'WindowsConfigurationArgs']]]):
        pulumi.set(self, "os_configuration", value)


if not MYPY:
    class OsSapConfigurationArgsDict(TypedDict):
        """
        Defines the OS and SAP Configurations for Deployment
        """
        deployer_vm_packages: NotRequired[pulumi.Input['DeployerVmPackagesArgsDict']]
        """
        The url and storage account ID where deployer VM packages are uploaded
        """
        sap_fqdn: NotRequired[pulumi.Input[str]]
        """
        The FQDN to set for the SAP system
        """
elif False:
    OsSapConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OsSapConfigurationArgs:
    def __init__(__self__, *,
                 deployer_vm_packages: Optional[pulumi.Input['DeployerVmPackagesArgs']] = None,
                 sap_fqdn: Optional[pulumi.Input[str]] = None):
        """
        Defines the OS and SAP Configurations for Deployment
        :param pulumi.Input['DeployerVmPackagesArgs'] deployer_vm_packages: The url and storage account ID where deployer VM packages are uploaded
        :param pulumi.Input[str] sap_fqdn: The FQDN to set for the SAP system
        """
        if deployer_vm_packages is not None:
            pulumi.set(__self__, "deployer_vm_packages", deployer_vm_packages)
        if sap_fqdn is not None:
            pulumi.set(__self__, "sap_fqdn", sap_fqdn)

    @property
    @pulumi.getter(name="deployerVmPackages")
    def deployer_vm_packages(self) -> Optional[pulumi.Input['DeployerVmPackagesArgs']]:
        """
        The url and storage account ID where deployer VM packages are uploaded
        """
        return pulumi.get(self, "deployer_vm_packages")

    @deployer_vm_packages.setter
    def deployer_vm_packages(self, value: Optional[pulumi.Input['DeployerVmPackagesArgs']]):
        pulumi.set(self, "deployer_vm_packages", value)

    @property
    @pulumi.getter(name="sapFqdn")
    def sap_fqdn(self) -> Optional[pulumi.Input[str]]:
        """
        The FQDN to set for the SAP system
        """
        return pulumi.get(self, "sap_fqdn")

    @sap_fqdn.setter
    def sap_fqdn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sap_fqdn", value)


if not MYPY:
    class SAPInstallWithoutOSConfigSoftwareConfigurationArgsDict(TypedDict):
        """
        The SAP Software configuration Input when the software is to be installed by service without OS Configurations
        """
        bom_url: pulumi.Input[str]
        """
        The URL to the SAP Build of Materials(BOM) file.
        """
        sap_bits_storage_account_id: pulumi.Input[str]
        """
        The SAP bits storage account id.
        """
        software_installation_type: pulumi.Input[str]
        """
        The SAP software installation Type.
        Expected value is 'SAPInstallWithoutOSConfig'.
        """
        software_version: pulumi.Input[str]
        """
        The software version to install.
        """
        high_availability_software_configuration: NotRequired[pulumi.Input['HighAvailabilitySoftwareConfigurationArgsDict']]
        """
        Gets or sets the HA software configuration.
        """
elif False:
    SAPInstallWithoutOSConfigSoftwareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SAPInstallWithoutOSConfigSoftwareConfigurationArgs:
    def __init__(__self__, *,
                 bom_url: pulumi.Input[str],
                 sap_bits_storage_account_id: pulumi.Input[str],
                 software_installation_type: pulumi.Input[str],
                 software_version: pulumi.Input[str],
                 high_availability_software_configuration: Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']] = None):
        """
        The SAP Software configuration Input when the software is to be installed by service without OS Configurations
        :param pulumi.Input[str] bom_url: The URL to the SAP Build of Materials(BOM) file.
        :param pulumi.Input[str] sap_bits_storage_account_id: The SAP bits storage account id.
        :param pulumi.Input[str] software_installation_type: The SAP software installation Type.
               Expected value is 'SAPInstallWithoutOSConfig'.
        :param pulumi.Input[str] software_version: The software version to install.
        :param pulumi.Input['HighAvailabilitySoftwareConfigurationArgs'] high_availability_software_configuration: Gets or sets the HA software configuration.
        """
        pulumi.set(__self__, "bom_url", bom_url)
        pulumi.set(__self__, "sap_bits_storage_account_id", sap_bits_storage_account_id)
        pulumi.set(__self__, "software_installation_type", 'SAPInstallWithoutOSConfig')
        pulumi.set(__self__, "software_version", software_version)
        if high_availability_software_configuration is not None:
            pulumi.set(__self__, "high_availability_software_configuration", high_availability_software_configuration)

    @property
    @pulumi.getter(name="bomUrl")
    def bom_url(self) -> pulumi.Input[str]:
        """
        The URL to the SAP Build of Materials(BOM) file.
        """
        return pulumi.get(self, "bom_url")

    @bom_url.setter
    def bom_url(self, value: pulumi.Input[str]):
        pulumi.set(self, "bom_url", value)

    @property
    @pulumi.getter(name="sapBitsStorageAccountId")
    def sap_bits_storage_account_id(self) -> pulumi.Input[str]:
        """
        The SAP bits storage account id.
        """
        return pulumi.get(self, "sap_bits_storage_account_id")

    @sap_bits_storage_account_id.setter
    def sap_bits_storage_account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "sap_bits_storage_account_id", value)

    @property
    @pulumi.getter(name="softwareInstallationType")
    def software_installation_type(self) -> pulumi.Input[str]:
        """
        The SAP software installation Type.
        Expected value is 'SAPInstallWithoutOSConfig'.
        """
        return pulumi.get(self, "software_installation_type")

    @software_installation_type.setter
    def software_installation_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "software_installation_type", value)

    @property
    @pulumi.getter(name="softwareVersion")
    def software_version(self) -> pulumi.Input[str]:
        """
        The software version to install.
        """
        return pulumi.get(self, "software_version")

    @software_version.setter
    def software_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "software_version", value)

    @property
    @pulumi.getter(name="highAvailabilitySoftwareConfiguration")
    def high_availability_software_configuration(self) -> Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']]:
        """
        Gets or sets the HA software configuration.
        """
        return pulumi.get(self, "high_availability_software_configuration")

    @high_availability_software_configuration.setter
    def high_availability_software_configuration(self, value: Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']]):
        pulumi.set(self, "high_availability_software_configuration", value)


if not MYPY:
    class ServiceInitiatedSoftwareConfigurationArgsDict(TypedDict):
        """
        The SAP Software configuration Input when the software is to be installed by service.
        """
        bom_url: pulumi.Input[str]
        """
        The URL to the SAP Build of Materials(BOM) file.
        """
        sap_bits_storage_account_id: pulumi.Input[str]
        """
        The SAP bits storage account id.
        """
        sap_fqdn: pulumi.Input[str]
        """
        The FQDN to set for the SAP system during install.
        """
        software_installation_type: pulumi.Input[str]
        """
        The SAP software installation Type.
        Expected value is 'ServiceInitiated'.
        """
        software_version: pulumi.Input[str]
        """
        The software version to install.
        """
        ssh_private_key: pulumi.Input[str]
        """
        The SSH private key.
        """
        high_availability_software_configuration: NotRequired[pulumi.Input['HighAvailabilitySoftwareConfigurationArgsDict']]
        """
        Gets or sets the HA software configuration.
        """
elif False:
    ServiceInitiatedSoftwareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ServiceInitiatedSoftwareConfigurationArgs:
    def __init__(__self__, *,
                 bom_url: pulumi.Input[str],
                 sap_bits_storage_account_id: pulumi.Input[str],
                 sap_fqdn: pulumi.Input[str],
                 software_installation_type: pulumi.Input[str],
                 software_version: pulumi.Input[str],
                 ssh_private_key: pulumi.Input[str],
                 high_availability_software_configuration: Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']] = None):
        """
        The SAP Software configuration Input when the software is to be installed by service.
        :param pulumi.Input[str] bom_url: The URL to the SAP Build of Materials(BOM) file.
        :param pulumi.Input[str] sap_bits_storage_account_id: The SAP bits storage account id.
        :param pulumi.Input[str] sap_fqdn: The FQDN to set for the SAP system during install.
        :param pulumi.Input[str] software_installation_type: The SAP software installation Type.
               Expected value is 'ServiceInitiated'.
        :param pulumi.Input[str] software_version: The software version to install.
        :param pulumi.Input[str] ssh_private_key: The SSH private key.
        :param pulumi.Input['HighAvailabilitySoftwareConfigurationArgs'] high_availability_software_configuration: Gets or sets the HA software configuration.
        """
        pulumi.set(__self__, "bom_url", bom_url)
        pulumi.set(__self__, "sap_bits_storage_account_id", sap_bits_storage_account_id)
        pulumi.set(__self__, "sap_fqdn", sap_fqdn)
        pulumi.set(__self__, "software_installation_type", 'ServiceInitiated')
        pulumi.set(__self__, "software_version", software_version)
        pulumi.set(__self__, "ssh_private_key", ssh_private_key)
        if high_availability_software_configuration is not None:
            pulumi.set(__self__, "high_availability_software_configuration", high_availability_software_configuration)

    @property
    @pulumi.getter(name="bomUrl")
    def bom_url(self) -> pulumi.Input[str]:
        """
        The URL to the SAP Build of Materials(BOM) file.
        """
        return pulumi.get(self, "bom_url")

    @bom_url.setter
    def bom_url(self, value: pulumi.Input[str]):
        pulumi.set(self, "bom_url", value)

    @property
    @pulumi.getter(name="sapBitsStorageAccountId")
    def sap_bits_storage_account_id(self) -> pulumi.Input[str]:
        """
        The SAP bits storage account id.
        """
        return pulumi.get(self, "sap_bits_storage_account_id")

    @sap_bits_storage_account_id.setter
    def sap_bits_storage_account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "sap_bits_storage_account_id", value)

    @property
    @pulumi.getter(name="sapFqdn")
    def sap_fqdn(self) -> pulumi.Input[str]:
        """
        The FQDN to set for the SAP system during install.
        """
        return pulumi.get(self, "sap_fqdn")

    @sap_fqdn.setter
    def sap_fqdn(self, value: pulumi.Input[str]):
        pulumi.set(self, "sap_fqdn", value)

    @property
    @pulumi.getter(name="softwareInstallationType")
    def software_installation_type(self) -> pulumi.Input[str]:
        """
        The SAP software installation Type.
        Expected value is 'ServiceInitiated'.
        """
        return pulumi.get(self, "software_installation_type")

    @software_installation_type.setter
    def software_installation_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "software_installation_type", value)

    @property
    @pulumi.getter(name="softwareVersion")
    def software_version(self) -> pulumi.Input[str]:
        """
        The software version to install.
        """
        return pulumi.get(self, "software_version")

    @software_version.setter
    def software_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "software_version", value)

    @property
    @pulumi.getter(name="sshPrivateKey")
    def ssh_private_key(self) -> pulumi.Input[str]:
        """
        The SSH private key.
        """
        return pulumi.get(self, "ssh_private_key")

    @ssh_private_key.setter
    def ssh_private_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "ssh_private_key", value)

    @property
    @pulumi.getter(name="highAvailabilitySoftwareConfiguration")
    def high_availability_software_configuration(self) -> Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']]:
        """
        Gets or sets the HA software configuration.
        """
        return pulumi.get(self, "high_availability_software_configuration")

    @high_availability_software_configuration.setter
    def high_availability_software_configuration(self, value: Optional[pulumi.Input['HighAvailabilitySoftwareConfigurationArgs']]):
        pulumi.set(self, "high_availability_software_configuration", value)


if not MYPY:
    class SharedStorageResourceNamesArgsDict(TypedDict):
        """
        The resource names object for shared storage.
        """
        shared_storage_account_name: NotRequired[pulumi.Input[str]]
        """
        The full name of the shared storage account. If it is not provided, it will be defaulted to {SID}nfs{guid of 15 chars}.
        """
        shared_storage_account_private_end_point_name: NotRequired[pulumi.Input[str]]
        """
        The full name of private end point for the shared storage account. If it is not provided, it will be defaulted to {storageAccountName}_pe
        """
elif False:
    SharedStorageResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SharedStorageResourceNamesArgs:
    def __init__(__self__, *,
                 shared_storage_account_name: Optional[pulumi.Input[str]] = None,
                 shared_storage_account_private_end_point_name: Optional[pulumi.Input[str]] = None):
        """
        The resource names object for shared storage.
        :param pulumi.Input[str] shared_storage_account_name: The full name of the shared storage account. If it is not provided, it will be defaulted to {SID}nfs{guid of 15 chars}.
        :param pulumi.Input[str] shared_storage_account_private_end_point_name: The full name of private end point for the shared storage account. If it is not provided, it will be defaulted to {storageAccountName}_pe
        """
        if shared_storage_account_name is not None:
            pulumi.set(__self__, "shared_storage_account_name", shared_storage_account_name)
        if shared_storage_account_private_end_point_name is not None:
            pulumi.set(__self__, "shared_storage_account_private_end_point_name", shared_storage_account_private_end_point_name)

    @property
    @pulumi.getter(name="sharedStorageAccountName")
    def shared_storage_account_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name of the shared storage account. If it is not provided, it will be defaulted to {SID}nfs{guid of 15 chars}.
        """
        return pulumi.get(self, "shared_storage_account_name")

    @shared_storage_account_name.setter
    def shared_storage_account_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "shared_storage_account_name", value)

    @property
    @pulumi.getter(name="sharedStorageAccountPrivateEndPointName")
    def shared_storage_account_private_end_point_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name of private end point for the shared storage account. If it is not provided, it will be defaulted to {storageAccountName}_pe
        """
        return pulumi.get(self, "shared_storage_account_private_end_point_name")

    @shared_storage_account_private_end_point_name.setter
    def shared_storage_account_private_end_point_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "shared_storage_account_private_end_point_name", value)


if not MYPY:
    class SingleServerConfigurationArgsDict(TypedDict):
        """
        Gets or sets the single server configuration. For prerequisites for creating the infrastructure, please see [here](https://go.microsoft.com/fwlink/?linkid=2212611&clcid=0x409)
        """
        app_resource_group: pulumi.Input[str]
        """
        The application resource group where SAP system resources will be deployed.
        """
        deployment_type: pulumi.Input[str]
        """
        The type of SAP deployment, single server or Three tier.
        Expected value is 'SingleServer'.
        """
        subnet_id: pulumi.Input[str]
        """
        The subnet id.
        """
        virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgsDict']
        """
        Gets or sets the virtual machine configuration.
        """
        custom_resource_names: NotRequired[pulumi.Input['SingleServerFullResourceNamesArgsDict']]
        """
        The set of custom names to be used for underlying azure resources that are part of the SAP system.
        """
        database_type: NotRequired[pulumi.Input[Union[str, 'SAPDatabaseType']]]
        """
        The database type.
        """
        db_disk_configuration: NotRequired[pulumi.Input['DiskConfigurationArgsDict']]
        """
        Gets or sets the disk configuration.
        """
        network_configuration: NotRequired[pulumi.Input['NetworkConfigurationArgsDict']]
        """
        Network configuration for the server
        """
elif False:
    SingleServerConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SingleServerConfigurationArgs:
    def __init__(__self__, *,
                 app_resource_group: pulumi.Input[str],
                 deployment_type: pulumi.Input[str],
                 subnet_id: pulumi.Input[str],
                 virtual_machine_configuration: pulumi.Input['VirtualMachineConfigurationArgs'],
                 custom_resource_names: Optional[pulumi.Input['SingleServerFullResourceNamesArgs']] = None,
                 database_type: Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]] = None,
                 db_disk_configuration: Optional[pulumi.Input['DiskConfigurationArgs']] = None,
                 network_configuration: Optional[pulumi.Input['NetworkConfigurationArgs']] = None):
        """
        Gets or sets the single server configuration. For prerequisites for creating the infrastructure, please see [here](https://go.microsoft.com/fwlink/?linkid=2212611&clcid=0x409)
        :param pulumi.Input[str] app_resource_group: The application resource group where SAP system resources will be deployed.
        :param pulumi.Input[str] deployment_type: The type of SAP deployment, single server or Three tier.
               Expected value is 'SingleServer'.
        :param pulumi.Input[str] subnet_id: The subnet id.
        :param pulumi.Input['VirtualMachineConfigurationArgs'] virtual_machine_configuration: Gets or sets the virtual machine configuration.
        :param pulumi.Input['SingleServerFullResourceNamesArgs'] custom_resource_names: The set of custom names to be used for underlying azure resources that are part of the SAP system.
        :param pulumi.Input[Union[str, 'SAPDatabaseType']] database_type: The database type.
        :param pulumi.Input['DiskConfigurationArgs'] db_disk_configuration: Gets or sets the disk configuration.
        :param pulumi.Input['NetworkConfigurationArgs'] network_configuration: Network configuration for the server
        """
        pulumi.set(__self__, "app_resource_group", app_resource_group)
        pulumi.set(__self__, "deployment_type", 'SingleServer')
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "virtual_machine_configuration", virtual_machine_configuration)
        if custom_resource_names is not None:
            pulumi.set(__self__, "custom_resource_names", custom_resource_names)
        if database_type is not None:
            pulumi.set(__self__, "database_type", database_type)
        if db_disk_configuration is not None:
            pulumi.set(__self__, "db_disk_configuration", db_disk_configuration)
        if network_configuration is not None:
            pulumi.set(__self__, "network_configuration", network_configuration)

    @property
    @pulumi.getter(name="appResourceGroup")
    def app_resource_group(self) -> pulumi.Input[str]:
        """
        The application resource group where SAP system resources will be deployed.
        """
        return pulumi.get(self, "app_resource_group")

    @app_resource_group.setter
    def app_resource_group(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_resource_group", value)

    @property
    @pulumi.getter(name="deploymentType")
    def deployment_type(self) -> pulumi.Input[str]:
        """
        The type of SAP deployment, single server or Three tier.
        Expected value is 'SingleServer'.
        """
        return pulumi.get(self, "deployment_type")

    @deployment_type.setter
    def deployment_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "deployment_type", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        The subnet id.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="virtualMachineConfiguration")
    def virtual_machine_configuration(self) -> pulumi.Input['VirtualMachineConfigurationArgs']:
        """
        Gets or sets the virtual machine configuration.
        """
        return pulumi.get(self, "virtual_machine_configuration")

    @virtual_machine_configuration.setter
    def virtual_machine_configuration(self, value: pulumi.Input['VirtualMachineConfigurationArgs']):
        pulumi.set(self, "virtual_machine_configuration", value)

    @property
    @pulumi.getter(name="customResourceNames")
    def custom_resource_names(self) -> Optional[pulumi.Input['SingleServerFullResourceNamesArgs']]:
        """
        The set of custom names to be used for underlying azure resources that are part of the SAP system.
        """
        return pulumi.get(self, "custom_resource_names")

    @custom_resource_names.setter
    def custom_resource_names(self, value: Optional[pulumi.Input['SingleServerFullResourceNamesArgs']]):
        pulumi.set(self, "custom_resource_names", value)

    @property
    @pulumi.getter(name="databaseType")
    def database_type(self) -> Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]]:
        """
        The database type.
        """
        return pulumi.get(self, "database_type")

    @database_type.setter
    def database_type(self, value: Optional[pulumi.Input[Union[str, 'SAPDatabaseType']]]):
        pulumi.set(self, "database_type", value)

    @property
    @pulumi.getter(name="dbDiskConfiguration")
    def db_disk_configuration(self) -> Optional[pulumi.Input['DiskConfigurationArgs']]:
        """
        Gets or sets the disk configuration.
        """
        return pulumi.get(self, "db_disk_configuration")

    @db_disk_configuration.setter
    def db_disk_configuration(self, value: Optional[pulumi.Input['DiskConfigurationArgs']]):
        pulumi.set(self, "db_disk_configuration", value)

    @property
    @pulumi.getter(name="networkConfiguration")
    def network_configuration(self) -> Optional[pulumi.Input['NetworkConfigurationArgs']]:
        """
        Network configuration for the server
        """
        return pulumi.get(self, "network_configuration")

    @network_configuration.setter
    def network_configuration(self, value: Optional[pulumi.Input['NetworkConfigurationArgs']]):
        pulumi.set(self, "network_configuration", value)


if not MYPY:
    class SingleServerFullResourceNamesArgsDict(TypedDict):
        """
        The resource name object where the specified values will be full resource names of the corresponding resources in a single server SAP system.
        """
        naming_pattern_type: pulumi.Input[str]
        """
        The pattern type to be used for resource naming.
        Expected value is 'FullResourceName'.
        """
        virtual_machine: NotRequired[pulumi.Input['VirtualMachineResourceNamesArgsDict']]
        """
        The resource names object for virtual machine and related resources.
        """
elif False:
    SingleServerFullResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SingleServerFullResourceNamesArgs:
    def __init__(__self__, *,
                 naming_pattern_type: pulumi.Input[str],
                 virtual_machine: Optional[pulumi.Input['VirtualMachineResourceNamesArgs']] = None):
        """
        The resource name object where the specified values will be full resource names of the corresponding resources in a single server SAP system.
        :param pulumi.Input[str] naming_pattern_type: The pattern type to be used for resource naming.
               Expected value is 'FullResourceName'.
        :param pulumi.Input['VirtualMachineResourceNamesArgs'] virtual_machine: The resource names object for virtual machine and related resources.
        """
        pulumi.set(__self__, "naming_pattern_type", 'FullResourceName')
        if virtual_machine is not None:
            pulumi.set(__self__, "virtual_machine", virtual_machine)

    @property
    @pulumi.getter(name="namingPatternType")
    def naming_pattern_type(self) -> pulumi.Input[str]:
        """
        The pattern type to be used for resource naming.
        Expected value is 'FullResourceName'.
        """
        return pulumi.get(self, "naming_pattern_type")

    @naming_pattern_type.setter
    def naming_pattern_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "naming_pattern_type", value)

    @property
    @pulumi.getter(name="virtualMachine")
    def virtual_machine(self) -> Optional[pulumi.Input['VirtualMachineResourceNamesArgs']]:
        """
        The resource names object for virtual machine and related resources.
        """
        return pulumi.get(self, "virtual_machine")

    @virtual_machine.setter
    def virtual_machine(self, value: Optional[pulumi.Input['VirtualMachineResourceNamesArgs']]):
        pulumi.set(self, "virtual_machine", value)


if not MYPY:
    class SkipFileShareConfigurationArgsDict(TypedDict):
        """
        Gets or sets the file share configuration for scenarios where transport directory fileshare is not created or required.
        """
        configuration_type: pulumi.Input[str]
        """
        The type of file share config.
        Expected value is 'Skip'.
        """
elif False:
    SkipFileShareConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SkipFileShareConfigurationArgs:
    def __init__(__self__, *,
                 configuration_type: pulumi.Input[str]):
        """
        Gets or sets the file share configuration for scenarios where transport directory fileshare is not created or required.
        :param pulumi.Input[str] configuration_type: The type of file share config.
               Expected value is 'Skip'.
        """
        pulumi.set(__self__, "configuration_type", 'Skip')

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> pulumi.Input[str]:
        """
        The type of file share config.
        Expected value is 'Skip'.
        """
        return pulumi.get(self, "configuration_type")

    @configuration_type.setter
    def configuration_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "configuration_type", value)


if not MYPY:
    class SshConfigurationArgsDict(TypedDict):
        """
        SSH configuration for Linux based VMs running on Azure
        """
        public_keys: NotRequired[pulumi.Input[Sequence[pulumi.Input['SshPublicKeyArgsDict']]]]
        """
        The list of SSH public keys used to authenticate with linux based VMs.
        """
elif False:
    SshConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SshConfigurationArgs:
    def __init__(__self__, *,
                 public_keys: Optional[pulumi.Input[Sequence[pulumi.Input['SshPublicKeyArgs']]]] = None):
        """
        SSH configuration for Linux based VMs running on Azure
        :param pulumi.Input[Sequence[pulumi.Input['SshPublicKeyArgs']]] public_keys: The list of SSH public keys used to authenticate with linux based VMs.
        """
        if public_keys is not None:
            pulumi.set(__self__, "public_keys", public_keys)

    @property
    @pulumi.getter(name="publicKeys")
    def public_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SshPublicKeyArgs']]]]:
        """
        The list of SSH public keys used to authenticate with linux based VMs.
        """
        return pulumi.get(self, "public_keys")

    @public_keys.setter
    def public_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SshPublicKeyArgs']]]]):
        pulumi.set(self, "public_keys", value)


if not MYPY:
    class SshKeyPairArgsDict(TypedDict):
        """
        The SSH Key-pair used to authenticate with the VM. The key needs to be at least 2048-bit and in ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on Linux and Mac for Linux VMs in Azure](https://docs.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        """
        private_key: NotRequired[pulumi.Input[str]]
        """
        SSH private key.
        """
        public_key: NotRequired[pulumi.Input[str]]
        """
        SSH public key
        """
elif False:
    SshKeyPairArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SshKeyPairArgs:
    def __init__(__self__, *,
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_key: Optional[pulumi.Input[str]] = None):
        """
        The SSH Key-pair used to authenticate with the VM. The key needs to be at least 2048-bit and in ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on Linux and Mac for Linux VMs in Azure](https://docs.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        :param pulumi.Input[str] private_key: SSH private key.
        :param pulumi.Input[str] public_key: SSH public key
        """
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if public_key is not None:
            pulumi.set(__self__, "public_key", public_key)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        SSH private key.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> Optional[pulumi.Input[str]]:
        """
        SSH public key
        """
        return pulumi.get(self, "public_key")

    @public_key.setter
    def public_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_key", value)


if not MYPY:
    class SshPublicKeyArgsDict(TypedDict):
        """
        Contains information about SSH certificate public key and the path on the Linux VM where the public key is placed.
        """
        key_data: NotRequired[pulumi.Input[str]]
        """
        SSH public key certificate used to authenticate with the VM through ssh. The key needs to be at least 2048-bit and in ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on Linux and Mac for Linux VMs in Azure](https://docs.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        """
elif False:
    SshPublicKeyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SshPublicKeyArgs:
    def __init__(__self__, *,
                 key_data: Optional[pulumi.Input[str]] = None):
        """
        Contains information about SSH certificate public key and the path on the Linux VM where the public key is placed.
        :param pulumi.Input[str] key_data: SSH public key certificate used to authenticate with the VM through ssh. The key needs to be at least 2048-bit and in ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on Linux and Mac for Linux VMs in Azure](https://docs.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        """
        if key_data is not None:
            pulumi.set(__self__, "key_data", key_data)

    @property
    @pulumi.getter(name="keyData")
    def key_data(self) -> Optional[pulumi.Input[str]]:
        """
        SSH public key certificate used to authenticate with the VM through ssh. The key needs to be at least 2048-bit and in ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on Linux and Mac for Linux VMs in Azure](https://docs.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        """
        return pulumi.get(self, "key_data")

    @key_data.setter
    def key_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key_data", value)


if not MYPY:
    class StorageConfigurationArgsDict(TypedDict):
        """
        Gets or sets the storage configuration.
        """
        transport_file_share_configuration: NotRequired[pulumi.Input[Union['CreateAndMountFileShareConfigurationArgsDict', 'MountFileShareConfigurationArgsDict', 'SkipFileShareConfigurationArgsDict']]]
        """
        The properties of the transport directory attached to the VIS. The default for transportFileShareConfiguration is the createAndMount flow if storage configuration is missing.
        """
elif False:
    StorageConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StorageConfigurationArgs:
    def __init__(__self__, *,
                 transport_file_share_configuration: Optional[pulumi.Input[Union['CreateAndMountFileShareConfigurationArgs', 'MountFileShareConfigurationArgs', 'SkipFileShareConfigurationArgs']]] = None):
        """
        Gets or sets the storage configuration.
        :param pulumi.Input[Union['CreateAndMountFileShareConfigurationArgs', 'MountFileShareConfigurationArgs', 'SkipFileShareConfigurationArgs']] transport_file_share_configuration: The properties of the transport directory attached to the VIS. The default for transportFileShareConfiguration is the createAndMount flow if storage configuration is missing.
        """
        if transport_file_share_configuration is not None:
            pulumi.set(__self__, "transport_file_share_configuration", transport_file_share_configuration)

    @property
    @pulumi.getter(name="transportFileShareConfiguration")
    def transport_file_share_configuration(self) -> Optional[pulumi.Input[Union['CreateAndMountFileShareConfigurationArgs', 'MountFileShareConfigurationArgs', 'SkipFileShareConfigurationArgs']]]:
        """
        The properties of the transport directory attached to the VIS. The default for transportFileShareConfiguration is the createAndMount flow if storage configuration is missing.
        """
        return pulumi.get(self, "transport_file_share_configuration")

    @transport_file_share_configuration.setter
    def transport_file_share_configuration(self, value: Optional[pulumi.Input[Union['CreateAndMountFileShareConfigurationArgs', 'MountFileShareConfigurationArgs', 'SkipFileShareConfigurationArgs']]]):
        pulumi.set(self, "transport_file_share_configuration", value)


if not MYPY:
    class ThreeTierConfigurationArgsDict(TypedDict):
        """
        Gets or sets the three tier SAP configuration. For prerequisites for creating the infrastructure, please see [here](https://go.microsoft.com/fwlink/?linkid=2212611&clcid=0x409)
        """
        app_resource_group: pulumi.Input[str]
        """
        The application resource group where SAP system resources will be deployed.
        """
        application_server: pulumi.Input['ApplicationServerConfigurationArgsDict']
        """
        The application server configuration.
        """
        central_server: pulumi.Input['CentralServerConfigurationArgsDict']
        """
        The central server configuration.
        """
        database_server: pulumi.Input['DatabaseConfigurationArgsDict']
        """
        The database configuration.
        """
        deployment_type: pulumi.Input[str]
        """
        The type of SAP deployment, single server or Three tier.
        Expected value is 'ThreeTier'.
        """
        custom_resource_names: NotRequired[pulumi.Input['ThreeTierFullResourceNamesArgsDict']]
        """
        The set of custom names to be used for underlying azure resources that are part of the SAP system.
        """
        high_availability_config: NotRequired[pulumi.Input['HighAvailabilityConfigurationArgsDict']]
        """
        The high availability configuration.
        """
        network_configuration: NotRequired[pulumi.Input['NetworkConfigurationArgsDict']]
        """
        Network configuration common to all servers
        """
        storage_configuration: NotRequired[pulumi.Input['StorageConfigurationArgsDict']]
        """
        The storage configuration.
        """
elif False:
    ThreeTierConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ThreeTierConfigurationArgs:
    def __init__(__self__, *,
                 app_resource_group: pulumi.Input[str],
                 application_server: pulumi.Input['ApplicationServerConfigurationArgs'],
                 central_server: pulumi.Input['CentralServerConfigurationArgs'],
                 database_server: pulumi.Input['DatabaseConfigurationArgs'],
                 deployment_type: pulumi.Input[str],
                 custom_resource_names: Optional[pulumi.Input['ThreeTierFullResourceNamesArgs']] = None,
                 high_availability_config: Optional[pulumi.Input['HighAvailabilityConfigurationArgs']] = None,
                 network_configuration: Optional[pulumi.Input['NetworkConfigurationArgs']] = None,
                 storage_configuration: Optional[pulumi.Input['StorageConfigurationArgs']] = None):
        """
        Gets or sets the three tier SAP configuration. For prerequisites for creating the infrastructure, please see [here](https://go.microsoft.com/fwlink/?linkid=2212611&clcid=0x409)
        :param pulumi.Input[str] app_resource_group: The application resource group where SAP system resources will be deployed.
        :param pulumi.Input['ApplicationServerConfigurationArgs'] application_server: The application server configuration.
        :param pulumi.Input['CentralServerConfigurationArgs'] central_server: The central server configuration.
        :param pulumi.Input['DatabaseConfigurationArgs'] database_server: The database configuration.
        :param pulumi.Input[str] deployment_type: The type of SAP deployment, single server or Three tier.
               Expected value is 'ThreeTier'.
        :param pulumi.Input['ThreeTierFullResourceNamesArgs'] custom_resource_names: The set of custom names to be used for underlying azure resources that are part of the SAP system.
        :param pulumi.Input['HighAvailabilityConfigurationArgs'] high_availability_config: The high availability configuration.
        :param pulumi.Input['NetworkConfigurationArgs'] network_configuration: Network configuration common to all servers
        :param pulumi.Input['StorageConfigurationArgs'] storage_configuration: The storage configuration.
        """
        pulumi.set(__self__, "app_resource_group", app_resource_group)
        pulumi.set(__self__, "application_server", application_server)
        pulumi.set(__self__, "central_server", central_server)
        pulumi.set(__self__, "database_server", database_server)
        pulumi.set(__self__, "deployment_type", 'ThreeTier')
        if custom_resource_names is not None:
            pulumi.set(__self__, "custom_resource_names", custom_resource_names)
        if high_availability_config is not None:
            pulumi.set(__self__, "high_availability_config", high_availability_config)
        if network_configuration is not None:
            pulumi.set(__self__, "network_configuration", network_configuration)
        if storage_configuration is not None:
            pulumi.set(__self__, "storage_configuration", storage_configuration)

    @property
    @pulumi.getter(name="appResourceGroup")
    def app_resource_group(self) -> pulumi.Input[str]:
        """
        The application resource group where SAP system resources will be deployed.
        """
        return pulumi.get(self, "app_resource_group")

    @app_resource_group.setter
    def app_resource_group(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_resource_group", value)

    @property
    @pulumi.getter(name="applicationServer")
    def application_server(self) -> pulumi.Input['ApplicationServerConfigurationArgs']:
        """
        The application server configuration.
        """
        return pulumi.get(self, "application_server")

    @application_server.setter
    def application_server(self, value: pulumi.Input['ApplicationServerConfigurationArgs']):
        pulumi.set(self, "application_server", value)

    @property
    @pulumi.getter(name="centralServer")
    def central_server(self) -> pulumi.Input['CentralServerConfigurationArgs']:
        """
        The central server configuration.
        """
        return pulumi.get(self, "central_server")

    @central_server.setter
    def central_server(self, value: pulumi.Input['CentralServerConfigurationArgs']):
        pulumi.set(self, "central_server", value)

    @property
    @pulumi.getter(name="databaseServer")
    def database_server(self) -> pulumi.Input['DatabaseConfigurationArgs']:
        """
        The database configuration.
        """
        return pulumi.get(self, "database_server")

    @database_server.setter
    def database_server(self, value: pulumi.Input['DatabaseConfigurationArgs']):
        pulumi.set(self, "database_server", value)

    @property
    @pulumi.getter(name="deploymentType")
    def deployment_type(self) -> pulumi.Input[str]:
        """
        The type of SAP deployment, single server or Three tier.
        Expected value is 'ThreeTier'.
        """
        return pulumi.get(self, "deployment_type")

    @deployment_type.setter
    def deployment_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "deployment_type", value)

    @property
    @pulumi.getter(name="customResourceNames")
    def custom_resource_names(self) -> Optional[pulumi.Input['ThreeTierFullResourceNamesArgs']]:
        """
        The set of custom names to be used for underlying azure resources that are part of the SAP system.
        """
        return pulumi.get(self, "custom_resource_names")

    @custom_resource_names.setter
    def custom_resource_names(self, value: Optional[pulumi.Input['ThreeTierFullResourceNamesArgs']]):
        pulumi.set(self, "custom_resource_names", value)

    @property
    @pulumi.getter(name="highAvailabilityConfig")
    def high_availability_config(self) -> Optional[pulumi.Input['HighAvailabilityConfigurationArgs']]:
        """
        The high availability configuration.
        """
        return pulumi.get(self, "high_availability_config")

    @high_availability_config.setter
    def high_availability_config(self, value: Optional[pulumi.Input['HighAvailabilityConfigurationArgs']]):
        pulumi.set(self, "high_availability_config", value)

    @property
    @pulumi.getter(name="networkConfiguration")
    def network_configuration(self) -> Optional[pulumi.Input['NetworkConfigurationArgs']]:
        """
        Network configuration common to all servers
        """
        return pulumi.get(self, "network_configuration")

    @network_configuration.setter
    def network_configuration(self, value: Optional[pulumi.Input['NetworkConfigurationArgs']]):
        pulumi.set(self, "network_configuration", value)

    @property
    @pulumi.getter(name="storageConfiguration")
    def storage_configuration(self) -> Optional[pulumi.Input['StorageConfigurationArgs']]:
        """
        The storage configuration.
        """
        return pulumi.get(self, "storage_configuration")

    @storage_configuration.setter
    def storage_configuration(self, value: Optional[pulumi.Input['StorageConfigurationArgs']]):
        pulumi.set(self, "storage_configuration", value)


if not MYPY:
    class ThreeTierFullResourceNamesArgsDict(TypedDict):
        """
        The resource name object where the specified values will be full resource names of the corresponding resources in a three tier SAP system.
        """
        naming_pattern_type: pulumi.Input[str]
        """
        The pattern type to be used for resource naming.
        Expected value is 'FullResourceName'.
        """
        application_server: NotRequired[pulumi.Input['ApplicationServerFullResourceNamesArgsDict']]
        """
        The full resource names object for application layer resources. The number of entries in this list should be equal to the number VMs to be created for application layer.
        """
        central_server: NotRequired[pulumi.Input['CentralServerFullResourceNamesArgsDict']]
        """
        The full resource names object for central server layer resources.
        """
        database_server: NotRequired[pulumi.Input['DatabaseServerFullResourceNamesArgsDict']]
        """
        The full resource names object for database layer resources. The number of entries in this list should be equal to the number VMs to be created for database layer.
        """
        shared_storage: NotRequired[pulumi.Input['SharedStorageResourceNamesArgsDict']]
        """
        The resource names object for shared storage.
        """
elif False:
    ThreeTierFullResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ThreeTierFullResourceNamesArgs:
    def __init__(__self__, *,
                 naming_pattern_type: pulumi.Input[str],
                 application_server: Optional[pulumi.Input['ApplicationServerFullResourceNamesArgs']] = None,
                 central_server: Optional[pulumi.Input['CentralServerFullResourceNamesArgs']] = None,
                 database_server: Optional[pulumi.Input['DatabaseServerFullResourceNamesArgs']] = None,
                 shared_storage: Optional[pulumi.Input['SharedStorageResourceNamesArgs']] = None):
        """
        The resource name object where the specified values will be full resource names of the corresponding resources in a three tier SAP system.
        :param pulumi.Input[str] naming_pattern_type: The pattern type to be used for resource naming.
               Expected value is 'FullResourceName'.
        :param pulumi.Input['ApplicationServerFullResourceNamesArgs'] application_server: The full resource names object for application layer resources. The number of entries in this list should be equal to the number VMs to be created for application layer.
        :param pulumi.Input['CentralServerFullResourceNamesArgs'] central_server: The full resource names object for central server layer resources.
        :param pulumi.Input['DatabaseServerFullResourceNamesArgs'] database_server: The full resource names object for database layer resources. The number of entries in this list should be equal to the number VMs to be created for database layer.
        :param pulumi.Input['SharedStorageResourceNamesArgs'] shared_storage: The resource names object for shared storage.
        """
        pulumi.set(__self__, "naming_pattern_type", 'FullResourceName')
        if application_server is not None:
            pulumi.set(__self__, "application_server", application_server)
        if central_server is not None:
            pulumi.set(__self__, "central_server", central_server)
        if database_server is not None:
            pulumi.set(__self__, "database_server", database_server)
        if shared_storage is not None:
            pulumi.set(__self__, "shared_storage", shared_storage)

    @property
    @pulumi.getter(name="namingPatternType")
    def naming_pattern_type(self) -> pulumi.Input[str]:
        """
        The pattern type to be used for resource naming.
        Expected value is 'FullResourceName'.
        """
        return pulumi.get(self, "naming_pattern_type")

    @naming_pattern_type.setter
    def naming_pattern_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "naming_pattern_type", value)

    @property
    @pulumi.getter(name="applicationServer")
    def application_server(self) -> Optional[pulumi.Input['ApplicationServerFullResourceNamesArgs']]:
        """
        The full resource names object for application layer resources. The number of entries in this list should be equal to the number VMs to be created for application layer.
        """
        return pulumi.get(self, "application_server")

    @application_server.setter
    def application_server(self, value: Optional[pulumi.Input['ApplicationServerFullResourceNamesArgs']]):
        pulumi.set(self, "application_server", value)

    @property
    @pulumi.getter(name="centralServer")
    def central_server(self) -> Optional[pulumi.Input['CentralServerFullResourceNamesArgs']]:
        """
        The full resource names object for central server layer resources.
        """
        return pulumi.get(self, "central_server")

    @central_server.setter
    def central_server(self, value: Optional[pulumi.Input['CentralServerFullResourceNamesArgs']]):
        pulumi.set(self, "central_server", value)

    @property
    @pulumi.getter(name="databaseServer")
    def database_server(self) -> Optional[pulumi.Input['DatabaseServerFullResourceNamesArgs']]:
        """
        The full resource names object for database layer resources. The number of entries in this list should be equal to the number VMs to be created for database layer.
        """
        return pulumi.get(self, "database_server")

    @database_server.setter
    def database_server(self, value: Optional[pulumi.Input['DatabaseServerFullResourceNamesArgs']]):
        pulumi.set(self, "database_server", value)

    @property
    @pulumi.getter(name="sharedStorage")
    def shared_storage(self) -> Optional[pulumi.Input['SharedStorageResourceNamesArgs']]:
        """
        The resource names object for shared storage.
        """
        return pulumi.get(self, "shared_storage")

    @shared_storage.setter
    def shared_storage(self, value: Optional[pulumi.Input['SharedStorageResourceNamesArgs']]):
        pulumi.set(self, "shared_storage", value)


if not MYPY:
    class VirtualMachineConfigurationArgsDict(TypedDict):
        """
        Defines the virtual machine configuration.
        """
        image_reference: pulumi.Input['ImageReferenceArgsDict']
        """
        The image reference.
        """
        os_profile: pulumi.Input['OSProfileArgsDict']
        """
        The OS profile.
        """
        vm_size: pulumi.Input[str]
        """
        The virtual machine size.
        """
elif False:
    VirtualMachineConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VirtualMachineConfigurationArgs:
    def __init__(__self__, *,
                 image_reference: pulumi.Input['ImageReferenceArgs'],
                 os_profile: pulumi.Input['OSProfileArgs'],
                 vm_size: pulumi.Input[str]):
        """
        Defines the virtual machine configuration.
        :param pulumi.Input['ImageReferenceArgs'] image_reference: The image reference.
        :param pulumi.Input['OSProfileArgs'] os_profile: The OS profile.
        :param pulumi.Input[str] vm_size: The virtual machine size.
        """
        pulumi.set(__self__, "image_reference", image_reference)
        pulumi.set(__self__, "os_profile", os_profile)
        pulumi.set(__self__, "vm_size", vm_size)

    @property
    @pulumi.getter(name="imageReference")
    def image_reference(self) -> pulumi.Input['ImageReferenceArgs']:
        """
        The image reference.
        """
        return pulumi.get(self, "image_reference")

    @image_reference.setter
    def image_reference(self, value: pulumi.Input['ImageReferenceArgs']):
        pulumi.set(self, "image_reference", value)

    @property
    @pulumi.getter(name="osProfile")
    def os_profile(self) -> pulumi.Input['OSProfileArgs']:
        """
        The OS profile.
        """
        return pulumi.get(self, "os_profile")

    @os_profile.setter
    def os_profile(self, value: pulumi.Input['OSProfileArgs']):
        pulumi.set(self, "os_profile", value)

    @property
    @pulumi.getter(name="vmSize")
    def vm_size(self) -> pulumi.Input[str]:
        """
        The virtual machine size.
        """
        return pulumi.get(self, "vm_size")

    @vm_size.setter
    def vm_size(self, value: pulumi.Input[str]):
        pulumi.set(self, "vm_size", value)


if not MYPY:
    class VirtualMachineResourceNamesArgsDict(TypedDict):
        """
        The resource names object for virtual machine and related resources.
        """
        data_disk_names: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[Sequence[pulumi.Input[str]]]]]]
        """
        The full resource names for virtual machine data disks. This is a dictionary containing list of names of data disks per volume. Currently supported volumes for database layer are ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os', 'backup']. For application and cs layers, only 'default' volume is supported
        """
        host_name: NotRequired[pulumi.Input[str]]
        """
        The full name for virtual-machine's host (computer name). Currently, ACSS only supports host names which are less than or equal to 13 characters long. If this value is not provided, vmName will be used as host name.
        """
        network_interfaces: NotRequired[pulumi.Input[Sequence[pulumi.Input['NetworkInterfaceResourceNamesArgsDict']]]]
        """
        The list of network interface name objects for the selected virtual machine. Currently, only one network interface is supported per virtual machine.
        """
        os_disk_name: NotRequired[pulumi.Input[str]]
        """
        The full name for OS disk attached to the VM. If this value is not provided, it will be named by ARM as per its default naming standards (prefixed with vm name). There is only one OS disk attached per Virtual Machine.
        """
        vm_name: NotRequired[pulumi.Input[str]]
        """
        The full name for virtual machine. The length of this field can be upto 64 characters. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}vm. In case of HA-AvZone systems, default name will be {SID}{app/ascs/db}z{a/b}vm with an incrementor at the end in case of more than 1 vm per layer. For distributed and HA-AvSet systems, default name will be {SID}{app/ascs/db}vm with an incrementor at the end in case of more than 1 vm per layer.
        """
elif False:
    VirtualMachineResourceNamesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class VirtualMachineResourceNamesArgs:
    def __init__(__self__, *,
                 data_disk_names: Optional[pulumi.Input[Mapping[str, pulumi.Input[Sequence[pulumi.Input[str]]]]]] = None,
                 host_name: Optional[pulumi.Input[str]] = None,
                 network_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkInterfaceResourceNamesArgs']]]] = None,
                 os_disk_name: Optional[pulumi.Input[str]] = None,
                 vm_name: Optional[pulumi.Input[str]] = None):
        """
        The resource names object for virtual machine and related resources.
        :param pulumi.Input[Mapping[str, pulumi.Input[Sequence[pulumi.Input[str]]]]] data_disk_names: The full resource names for virtual machine data disks. This is a dictionary containing list of names of data disks per volume. Currently supported volumes for database layer are ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os', 'backup']. For application and cs layers, only 'default' volume is supported
        :param pulumi.Input[str] host_name: The full name for virtual-machine's host (computer name). Currently, ACSS only supports host names which are less than or equal to 13 characters long. If this value is not provided, vmName will be used as host name.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkInterfaceResourceNamesArgs']]] network_interfaces: The list of network interface name objects for the selected virtual machine. Currently, only one network interface is supported per virtual machine.
        :param pulumi.Input[str] os_disk_name: The full name for OS disk attached to the VM. If this value is not provided, it will be named by ARM as per its default naming standards (prefixed with vm name). There is only one OS disk attached per Virtual Machine.
        :param pulumi.Input[str] vm_name: The full name for virtual machine. The length of this field can be upto 64 characters. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}vm. In case of HA-AvZone systems, default name will be {SID}{app/ascs/db}z{a/b}vm with an incrementor at the end in case of more than 1 vm per layer. For distributed and HA-AvSet systems, default name will be {SID}{app/ascs/db}vm with an incrementor at the end in case of more than 1 vm per layer.
        """
        if data_disk_names is not None:
            pulumi.set(__self__, "data_disk_names", data_disk_names)
        if host_name is not None:
            pulumi.set(__self__, "host_name", host_name)
        if network_interfaces is not None:
            pulumi.set(__self__, "network_interfaces", network_interfaces)
        if os_disk_name is not None:
            pulumi.set(__self__, "os_disk_name", os_disk_name)
        if vm_name is not None:
            pulumi.set(__self__, "vm_name", vm_name)

    @property
    @pulumi.getter(name="dataDiskNames")
    def data_disk_names(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[Sequence[pulumi.Input[str]]]]]]:
        """
        The full resource names for virtual machine data disks. This is a dictionary containing list of names of data disks per volume. Currently supported volumes for database layer are ['hana/data', 'hana/log', hana/shared', 'usr/sap', 'os', 'backup']. For application and cs layers, only 'default' volume is supported
        """
        return pulumi.get(self, "data_disk_names")

    @data_disk_names.setter
    def data_disk_names(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[Sequence[pulumi.Input[str]]]]]]):
        pulumi.set(self, "data_disk_names", value)

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for virtual-machine's host (computer name). Currently, ACSS only supports host names which are less than or equal to 13 characters long. If this value is not provided, vmName will be used as host name.
        """
        return pulumi.get(self, "host_name")

    @host_name.setter
    def host_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_name", value)

    @property
    @pulumi.getter(name="networkInterfaces")
    def network_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NetworkInterfaceResourceNamesArgs']]]]:
        """
        The list of network interface name objects for the selected virtual machine. Currently, only one network interface is supported per virtual machine.
        """
        return pulumi.get(self, "network_interfaces")

    @network_interfaces.setter
    def network_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkInterfaceResourceNamesArgs']]]]):
        pulumi.set(self, "network_interfaces", value)

    @property
    @pulumi.getter(name="osDiskName")
    def os_disk_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for OS disk attached to the VM. If this value is not provided, it will be named by ARM as per its default naming standards (prefixed with vm name). There is only one OS disk attached per Virtual Machine.
        """
        return pulumi.get(self, "os_disk_name")

    @os_disk_name.setter
    def os_disk_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "os_disk_name", value)

    @property
    @pulumi.getter(name="vmName")
    def vm_name(self) -> Optional[pulumi.Input[str]]:
        """
        The full name for virtual machine. The length of this field can be upto 64 characters. If name is not provided, service uses a default name based on the deployment type. For SingleServer, default name is {SID}vm. In case of HA-AvZone systems, default name will be {SID}{app/ascs/db}z{a/b}vm with an incrementor at the end in case of more than 1 vm per layer. For distributed and HA-AvSet systems, default name will be {SID}{app/ascs/db}vm with an incrementor at the end in case of more than 1 vm per layer.
        """
        return pulumi.get(self, "vm_name")

    @vm_name.setter
    def vm_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_name", value)


if not MYPY:
    class WindowsConfigurationArgsDict(TypedDict):
        """
        Specifies Windows operating system settings on the virtual machine.
        """
        os_type: pulumi.Input[str]
        """
        The OS Type
        Expected value is 'Windows'.
        """
elif False:
    WindowsConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WindowsConfigurationArgs:
    def __init__(__self__, *,
                 os_type: pulumi.Input[str]):
        """
        Specifies Windows operating system settings on the virtual machine.
        :param pulumi.Input[str] os_type: The OS Type
               Expected value is 'Windows'.
        """
        pulumi.set(__self__, "os_type", 'Windows')

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> pulumi.Input[str]:
        """
        The OS Type
        Expected value is 'Windows'.
        """
        return pulumi.get(self, "os_type")

    @os_type.setter
    def os_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "os_type", value)


